//============================================================================
// MapVoteAdminMessages
//============================================================================
//
class MapVoteAdminMessages extends Info config(MapVoteXM);
//
var(Maps) config string Message[51];

var bool bInitialized;

var string sDate;
var string sTime;

function PostBeginPlay ()
{
    Super.PostBeginPlay();

    if ( !bInitialized )
    {
       bInitialized = true;
       SaveConfig();
    }
}

function SaveAdminMessage(string PlayerName, string sMesg)
{
    local string sTemp, sComp;
    local int i;

    GetAbsoluteDateTime();

    sTemp = sDate$" - "$sTime$"  ";

    for (i=0; i<50; i++)
    {
        if (Message[i] == "")
        {
            if (i > 0)
            {
                sComp = Mid(Message[i-1], 50);
                if (InStr(sMesg, sComp) > 0)
                    break;
            }
            Message[i] = sTemp$PlayerName$": "$sMesg;
            SaveConfig();
            break;
        }
    }

    if (i == 50)
    {
       for (i=0; i<49; i++)
       {
            Message[i] = Message[i+1];
       }
       Message[49] = sTemp$PlayerName$": "$sMesg;
       SaveConfig();
    }
}

function DeleteMessages()
{
    local int i;

    for (i=0; i<50; i++)
    {
        Message[i] = "";
    }
    SaveConfig();
}

function GetAbsoluteDateTime()
{
	sDate = "";

	if (Level.Month < 10)
		sDate = sDate$"0"$Level.Month;
	else
		sDate = sDate$Level.Month;

	if (Level.Day < 10)
		sDate = sDate$"/0"$Level.Day;
	else
		sDate = sDate$"/"$Level.Day;

        sTime = "";

	if (Level.Hour < 10)
		sTime = sTime$"0"$Level.Hour;
	else
		sTime = sTime$Level.Hour;

	if (Level.Minute < 10)
		sTime = sTime$":0"$Level.Minute;
	else
		sTime = sTime$":"$Level.Minute;
}
//
defaultproperties
{
}
