//=================================================================
// MapVoteCommands
//=================================================================
//
class MapVoteCommands extends Mutator;
//
var MapVoteX myMut;

var bool bInitialized;
var bool bShowChatCommands;

var bool bUTCmds;
var bool bKillBots, bAddBot, bAdd2Bots;
var int BotTick, iBotKill, iBotAdd;
var string BotKillNick, BotAddNick;

replication
{
	reliable if (role == ROLE_Authority) // Replicate to client...
		         SendClient;
}

function PostBeginPlay()
{
    if (!bInitialized)
    {
       bInitialized = true;
       Level.Game.RegisterMessageMutator(Self);
       SetTimer(1.0, True);
       BotKillNick = "";
       BotAddNick  = "";
    }
    Super.PostBeginPlay();
}

event Timer()
{
	if (BotTick > 0)
	{
	    BotTick--;
	    if (BotTick == 0)
        {
            BotKillNick = "";
            BotAddNick  = "";
            iBotKill = 0;
            iBotAdd  = 0;
        }
	}
}

function bool MutatorBroadcastMessage( Actor Sender, Pawn Receiver, out coerce string Msg, optional bool bBeep, out optional name Type )
{
	if (Sender == Receiver && Sender.IsA('Spectator'))
	{
		if (CheckMessage(Mid(Msg,InStr(Msg,":")+1), Receiver))
		    return bShowChatCommands;
	}
	return Super.MutatorBroadcastMessage(Sender,Receiver,Msg,bBeep,Type);
}

function bool MutatorTeamMessage(Actor Sender, Pawn Receiver, PlayerReplicationInfo PRI, coerce string Msg, name Type, optional bool bBeep)
{
	if (Sender == Receiver)
	{
		if (CheckMessage(Msg, Receiver))
		    return bShowChatCommands;
	}
	return Super.MutatorTeamMessage(Sender,Receiver,PRI,Msg,Type,bBeep);
}

function bool CheckMessage(String Msg, Pawn Sender)
{
    local bool bSwitch, bDone, bAdmin;
    local int i, x;

    if (Left(Msg, 1) != "!")
        return false;

    bDone = false;
    bAdmin = Sender.PlayerReplicationInfo.bAdmin;

    if (TeamGamePlus(Level.Game)!=None && !TeamGamePlus(Level.Game).bNoTeamChanges)
        bSwitch = true;

	if (Sender.IsA('PlayerPawn') && !Sender.IsA('Spectator') && bSwitch && !bDone && !bUTCmds)
	{
		if (Msg ~= "!RED" || Msg ~= "!R")
		{
			ChangePlayerToTeam(PlayerPawn(Sender),0,false);
			bDone = true;
		}
		if (Msg ~= "!BLUE" || Msg ~= "!B")
		{
			ChangePlayerToTeam(PlayerPawn(Sender),1,false);
			bDone = true;
		}
		if (Msg ~= "!GREEN" || Msg ~= "!G")
		{
			ChangePlayerToTeam(PlayerPawn(Sender),2,false);
			bDone = true;
		}
		if (Msg ~= "!GOLD" || Msg ~= "!Y")
		{
			ChangePlayerToTeam(PlayerPawn(Sender),3,false);
			bDone = true;
		}
	}

	if (Sender.IsA('PlayerPawn') && !Sender.IsA('Spectator') && !bDone && !bUTCmds)
	{
		if (Msg ~= "!SPEC" || Msg ~= "!SPECTATE")
		{
			PlayerPawn(Sender).ClientTravel("?OverrideClass=Botpack.CHSpectator",TRAVEL_Relative, False);
			bDone = true;
		}
		else
		if (Msg ~= "!SU")
		{
		    PlayerPawn(Sender).ConsoleCommand("Suicide");
		    bDone = true;
		}
		else
		if (Msg ~= "!FD")
		{
		    PlayerPawn(Sender).ConsoleCommand("FeignDeath");
		    bDone = true;
		}
	}

	if (Sender.IsA('Spectator') && !bDone && !bUTCmds)
	{
		if (Msg ~= "!PLAY" || Msg ~= "!P")
		{
			PlayerPawn(Sender).ClientTravel("?OverrideClass=",TRAVEL_Relative, False);
			bDone = true;
		}
	}

    if (!Sender.IsA('Spectator') && !bDone)
    {
	   if (Msg ~= "!VOTE" || Msg ~= "!MAPVOTE" || Msg ~= "!V")
	   {
		   Level.Game.BaseMutator.Mutate("BDBMAPVOTE VOTEMENU",PlayerPawn(Sender));
		   bDone = true;
	   }

	   if (Msg ~= "!MVX")
	   {
		   Level.Game.BaseMutator.Mutate("MAPVOTEX VOTEMENU",PlayerPawn(Sender));
		   bDone = true;
	   }
    }

    if (Sender.IsA('PlayerPawn') && Level.NetMode != NM_StandAlone && !bDone && !bUTCmds)
    {
	   if (Msg ~= "!SDM" || Msg ~= "!SM")
	   {
		   Level.Game.BaseMutator.Mutate("SMARTDM MENU",PlayerPawn(Sender));
		   bDone = true;
	   }

	   if (Msg ~= "!SSB")
	   {
		   Level.Game.BaseMutator.Mutate("SMARTSB MENU",PlayerPawn(Sender));
		   bDone = true;
	   }

       if ( (Msg ~= "!SCTF") )
       {
           Level.Game.BaseMutator.Mutate("smartctf stats",PlayerPawn(Sender));
           bDone = true;
       }

	   if (Msg ~= "!IPC")
	   {
		   Level.Game.BaseMutator.Mutate("IpToCountry",PlayerPawn(Sender));
		   bDone = true;
	   }

       if (Msg == "!CMDS" || Msg == "!UTC")
       {
           Level.Game.BaseMutator.Mutate("UTCmds Help",PlayerPawn(Sender));
	       bDone = true;
	   }
    }

    if (Sender.IsA('PlayerPawn') && !Sender.IsA('Spectator') && !bDone )
    {
        if (Sender.PlayerReplicationInfo.bWaitingPlayer && Left(Caps(Msg), 4) != "!SSB")
		{
		    if (Left(Msg, 1) != "!")
		        Sender.ClientMessage("<< Please wait for the Game to start >>");
		    return False;
		}
        else
        if ( (Msg ~= "!KillBots" || Msg ~= "!KillBot"))
        {
		   if (bKillBots)
		   {
		       if (PlayerPawn(Sender).PlayerReplicationInfo.Playername != BotKillNick)
		       {
		           if (BotKillNick == "" && !bAdmin)
		           {
		               if (Msg ~= "!KillBots")
		                   BroadcastMessage("<< "$PlayerPawn(Sender).PlayerReplicationInfo.Playername$" has voted for Removing all Bots >>", true);
		               else
		                   BroadcastMessage("<< "$PlayerPawn(Sender).PlayerReplicationInfo.Playername$" has voted for Removing a Bot >>", true);
		           }
		           BotKillNick = PlayerPawn(Sender).PlayerReplicationInfo.Playername;
		           iBotKill++;
		           BotTick = 60;
		           if (iBotKill > 1 || Level.NetMode == NM_StandAlone || Level.Game.NumPlayers == 1 || bAdmin)
		           {
		               if (Msg ~= "!KillBot")
		               {
                           myMut.RemoveBot(False);
                           BroadcastMessage("<< A Bot has been removed >>", true);
                       }
                       else
                       {
                           myMut.RemoveBot(True);
                           BroadcastMessage("<< All Bots have been removed >>", true);
                       }
                       BotTick = 1;
		           }
		       }
		   }
		   else
		   {
		       PlayerPawn(Sender).ClientMessage("Player KillBots has been disabled.");
		   }
		   bDone = true;
        }
        else
        if (Msg ~= "!AddBot" || Msg ~= "!AddBots")
        {
		   if (bAddBot)
		   {
		       if (PlayerPawn(Sender).PlayerReplicationInfo.Playername != BotAddNick)
		       {
		           if (BotAddNick == "" && !bAdmin)
		           {
		               if (Msg ~= "!AddBots")
		                   BroadcastMessage("<< "$PlayerPawn(Sender).PlayerReplicationInfo.Playername$" has voted for Adding 2 Bots >>", true);
		               else
		                   BroadcastMessage("<< "$PlayerPawn(Sender).PlayerReplicationInfo.Playername$" has voted for Adding a Bot >>", true);
		           }
		           BotAddNick = PlayerPawn(Sender).PlayerReplicationInfo.Playername;
		           iBotAdd++;
		           BotTick = 60;
		           if (iBotAdd > 1 || Level.NetMode == NM_StandAlone || Level.Game.NumPlayers == 1 || bAdmin)
		           {
                       if (Msg ~= "!AddBots")
                           myMut.AddBot(Sender);
                       if (myMut.AddBot(Sender))
                           BroadcastMessage("<< Bot(s) have been added >>", true);
                       BotTick = 1;
		           }
		       }
		   }
		   else
		   {
		       PlayerPawn(Sender).ClientMessage("Player AddBots has been disabled.");
		   }
		   bDone = true;
        }
        else
        if (Msg ~= "!MaxBots" || Msg ~= "!AddMaxBots")
        {
		   if (bAddBot)
		   {
		       if (PlayerPawn(Sender).PlayerReplicationInfo.Playername != BotAddNick)
		       {
		           if (BotAddNick == "" && !bAdmin)
		           {
	                   BroadcastMessage("<< "$PlayerPawn(Sender).PlayerReplicationInfo.Playername$" has voted for Adding the Maximum Bots >>", true);
		           }
		           BotAddNick = PlayerPawn(Sender).PlayerReplicationInfo.Playername;
		           iBotAdd++;
		           BotTick = 60;
		           if (iBotAdd > 1 || Level.NetMode == NM_StandAlone || Level.Game.NumPlayers == 1 || bAdmin)
		           {
                       x = Level.Game.MaxPlayers - Level.Game.NumPlayers - DeathMatchPlus(Level.Game).NumBots;
                       for (i=0; i<x; i++)
                       {
                           if (myMut.AddBot(Sender) == False)
                           {
                               break;
                           }
                       }
                       BroadcastMessage("<< "$x$" Bots have been added >>", true);
                       BotTick = 1;
		           }
		       }
		   }
		   else
		   {
		       PlayerPawn(Sender).ClientMessage("Player AddBots has been disabled.");
		   }
		   bDone = true;
        }
    }
	return bDone;
}

function ChangePlayerToTeam(Pawn P, int teamnum, bool bInform)
{
	local bool oldbNoTeamChanges;

	if (P.IsA('Spectator') || teamnum == P.PlayerReplicationInfo.Team)
	{
		return;
	}

	if (teamnum < 0 || (TeamGamePlus(Level.Game)!= None && teamnum >= TeamGamePlus(Level.Game).MaxTeams))
	{
		return;
	}

	if (P.IsA('Bot'))
	{
		Bot(P).ConsoleCommand("taunt wave");
	}

	if (TeamGamePlus(Level.Game) != None)
	{
		oldbNoTeamChanges = TeamGamePlus(Level.Game).bNoTeamChanges;
		TeamGamePlus(Level.Game).bNoTeamChanges = False;
	}

	Level.Game.ChangeTeam(P, teamnum);

	if (TeamGamePlus(Level.Game) != None)
	{
		TeamGamePlus(Level.Game).bNoTeamChanges = oldbNoTeamChanges;
	}

	P.Died(None, '', P.Location);

	if (!DeathMatchPlus(Level.Game).bTournament)
	{
		P.PlayerReplicationInfo.Score += 1.0;
	}
}

simulated function SendClient(string Cmd)
{
	PlayerPawn(Owner).ConsoleCommand(Cmd);
}

defaultproperties
{
}
