//================================================================================
// MapVoteDefaultActors
//================================================================================
//
class MapVoteDefaultActors extends Info config(MapVoteX);

var() config string DefaultActor[100];         // actors from mvx.ini file

var bool bInitialized;

function PostBeginPlay()
{
	if (!bInitialized)
	{
	   bInitialized = true;
	   if (DefaultActor[0] == "")
	       GetDefaultActors();
	   SaveConfig();
    }
}

function GetDefaultActors()
{
    local string sTemp, sAct;
    local int i, j;

    sTemp = ConsoleCommand("Get Engine.GameEngine ServerActors");
    sTemp = Mid(sTemp, 1);

    j = InStr(sTemp, ")");
    if (j >= 0)
    {
        sTemp = Left(sTemp, j);
        sTemp = sTemp$",";
    }

    for (i=0; i<100; i++)
    {
        DefaultActor[i] = "";
    }

    for (i=0; i<100; i++)
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;
        sAct = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);
        DefaultActor[i] = sAct;
    }
    SaveConfig();
}

function RestoreDefaultActors()
{
    local string sTemp;
    local int i, j;

    if (DefaultActor[0] == "")
        return;

    sTemp = "(";
    for (i=0; i<100; i++)
    {
        if (DefaultActor[i] == "")
           break;
        if (InStr(DefaultActor[i], ";") < 0)
        {
            if (InStr(DefaultActor[i], "<") < 0)
            {
                j = InStr(DefaultActor[i], "\"");
                if (j >= 0)
                    sTemp = sTemp$DefaultActor[i]$",";
                else
                    sTemp = sTemp$"\""$DefaultActor[i]$"\",";
            }
        }
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";

    Level.ConsoleCommand("set Engine.GameEngine ServerActors "$sTemp);
    Log("Reset ServerActors: "$sTemp, 'MapVoteX');
}

function ClearDefaultActors()
{
    local string sTemp;
    local int i, j, x;

    x = 1;
    sTemp = ConsoleCommand("Get Engine.GameEngine ServerActors");
    for (i=0; i<100; i++)
    {
         j = InStr(sTemp, ",");
         if (j >= 0)
         {
             x++;
             sTemp = Mid(sTemp, j+1);
         }
         else
             break;
    }

    sTemp = "(";
    for (i=0; i<x; i++)
    {
         sTemp = sTemp$"\""$" "$"\",";
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";

    Log("Cleared ServerActors: "$sTemp, 'MapVoteX');
    Level.ConsoleCommand("set Engine.GameEngine ServerActors "$sTemp);
}

defaultproperties
{
}
