//================================================================================
// MapVoteDefaultPackages
//================================================================================
//
class MapVoteDefaultPackages extends Info config(MapVoteX);

var() config string DefaultPackage[100];       // packs from mvx.ini file

var bool bInitialized;

function PostBeginPlay()
{
	if (!bInitialized)
	{
	   bInitialized = true;
       if (DefaultPackage[0] == "")
	       GetDefaultPackages();
	   SaveConfig();
    }
}

function GetDefaultPackages()
{
    local string sTemp, sPack;
    local int i, j;

    sTemp = ConsoleCommand("Get Engine.GameEngine ServerPackages");
    sTemp = Mid(sTemp, 1);

    j = InStr(sTemp, ")");

    if (j >= 0)
    {
        sTemp = Left(sTemp, j);
        sTemp = sTemp$",";
    }

    for (i=0; i<100; i++)
    {
        DefaultPackage[i] = "";
    }

    for (i=0; i<100; i++)
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;
        sPack = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);
        DefaultPackage[i] = sPack;
    }
    SaveConfig();
}

function RestoreDefaultPackages()
{
    local string sTemp;
    local int i, j;

    if (DefaultPackage[0] == "")
        return;

    sTemp = "(";
    for (i=0; i<100; i++)
    {
        if (DefaultPackage[i] == "")
           break;
        if (InStr(DefaultPackage[i], ";") < 0)
        {
            if (InStr(DefaultPackage[i], "<") < 0)
            {
                j = InStr(DefaultPackage[i], "\"");
                if (j >= 0)
                    sTemp = sTemp$DefaultPackage[i]$",";
                else
                    sTemp = sTemp$"\""$DefaultPackage[i]$"\",";
            }
        }
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";

    Level.ConsoleCommand("set Engine.GameEngine ServerPackages "$sTemp);
    Log("Reset ServerPackages: "$sTemp, 'MapVoteX');
}

function ClearDefaultPackages()
{
    local string sTemp;
    local int i, j, x;

    x = 1;
    sTemp = ConsoleCommand("Get Engine.GameEngine ServerPackages");
    for (i=0; i<100; i++)
    {
         j = InStr(sTemp, ",");
         if (j >= 0)
         {
             x++;
             sTemp = Mid(sTemp, j+1);
         }
         else
             break;
    }

    sTemp = "(";
    for (i=0; i<x; i++)
    {
         sTemp = sTemp$"\""$" "$"\",";
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";

    Log("Cleared ServerPackages: "$sTemp, 'MapVoteX');
    Level.ConsoleCommand("set Engine.GameEngine ServerPackages "$sTemp);
}


defaultproperties
{
}

