//==============================================================================
// MapVote Game ReplicationInfo.
//==============================================================================
//
class MapVoteGRI extends ReplicationInfo;
//

var string sCode;
var string ListedMaps1[256];           // 0-256
var string ListedMaps2[256];
var string ListedMaps3[256];
var string ListedMaps4[256];

var string GameStuff1[205];            // 1-200=games
var string GameStuff2[205];            // 1-200=game maps / 202=this game / 203=map prefix / 204=gamecount
var string RestartMap;
var int    MaxNumMaps, PlayersMin, PlayersMax, LoadedMapNum;

var string DefMap;
var string GameName;
var string MapPref;
var string GameNames[200];
var string SvrName;

var bool   bDoubleClickVoting;
var bool   bGameEnded, bDoFavor;
var bool   bCoopGame;
var bool   bMapsOnly;
var bool   bVoting;

var int    TopGameCount[31];
var string TopGameNames[31];
var string TopMapCount[101];
var string TopMapNames[101];

struct Links
{
	var string Title;
	var string LinkURL;
};

var Links DropDownLinks[25];

replication
{
    reliable if ( Role == ROLE_Authority )
                 GameNames, sCode, bGameEnded, SvrName, bDoFavor, TopGameCount, TopGameNames, TopMapCount,
                 TopMapNames, DefMap, GameName, MapPref, bDoubleClickVoting, LoadedMapNum, bVoting;

    reliable if ( Role == ROLE_Authority )
                 RestartMap, DropDownLinks, MaxNumMaps, GameStuff1, GameStuff2, bCoopGame, PlayersMin, PlayersMax;

    reliable if ( Role == ROLE_Authority )
                 ListedMaps1, ListedMaps2, ListedMaps3, ListedMaps4;
}

function DropSetup(int iNum, string sTitle, string sUrl)
{
    DropDownLinks[iNum].Title = sTitle;
    DropDownLinks[iNum].LinkURL = sUrl;
}

simulated function string GetDropLink(int i, int j)
{
    local string sTemp;
    sTemp = "";

    if (j == 0)
        sTemp = DropDownLinks[i].Title;
    else
    if (j == 1)
        sTemp = DropDownLinks[i].LinkURL;

    return sTemp;
}

function DestroyGRI()
{
	Destroy();
}

//
defaultproperties
{
    RemoteRole=ROLE_SimulatedProxy
}