//================================================================================
// MapVoteGameAliases
//================================================================================
//
class MapVoteGameAliases extends Info config(MapVoteX);
//

struct CustConfig
{
	var string Name;
	var string Details;
};

var() config CustConfig Alias[200];

var bool bInitialized;

function PostBeginPlay()
{
	if (!bInitialized)
	{
	   bInitialized = true;
	   SaveConfig();
    }
}

function string CheckForAlias(string sAlias)
{
    local string sTemp;
    local int i;

    i = InStr(sAlias, ">");
    if (i < 0)
        return sAlias;

    sTemp = "";
    for (i=0; i<200; i++)
    {
        sTemp = Alias[i].Name;
        if (sTemp != "")
        {
            if (Left(sTemp, 1) != "<")
                sTemp = "<"$sTemp$">";
            if (sTemp ~= sAlias)
            {
               sTemp = Alias[i].Details;
               sTemp = RemoveRemarks(sTemp);
               if (sTemp != "")
               {
                   if (Right(sTemp, 1) != ",")
                       sTemp = sTemp$",";
                   break;
               }
            }
        }
    }
    return sTemp;
}

function string RemoveRemarks(string sLine)
{
    local string sTemp, sNew;
    local int i, j;

    if (InStr(sLine, ";") == -1)       // no remarks found
        return sLine;

    if (Right(sLine, 1) != ",")
        sLine = sLine$",";

    sNew = "";
    for (i=0; i<100; i++)
    {
        j = InStr(sLine, ",");
        if (j == -1)
            break;
        sTemp = Left(sLine, j+1);      // include comma
        sLine = Mid(sLine, j+1);
        if (Left(sTemp, 1) != ";")
            sNew = sNew$sTemp;
    }
    Log("Alias After Remarked = "$sNew, 'MapVoteX');
    return sNew;
}

defaultproperties
{
}
