//============================================================================
//                             MapVoteIdler
//        Taken from KickIdlePlayers by Chad (m0rpheusman@yahoo.com)
//============================================================================
//
class MapVoteIdler extends Mutator Config(MapVoteX);

var config bool bUseSendToSpec;
var config int  IdleKickTime;

var bool Initialized;
var int  LastCheck;
var rotator CurRotation;

struct FireRecord                               // player fire records
{
	var bool bFireLog;                          // is player monitored - heehee
	var bool bAboutToBeKicked;
	var bool bJustDied;                         // Check if the player just died
	var int  LastFireTime;                      // start of Fire monitor
	var int  LastRotateTime;                    // start of Rotation monitor
	var rotator TestRotation;                   // Test if Rotation changed within 5 seconds
	var Weapon OldWeapon;                       // What weapon the player is using
};

var FireRecord FireRecords[50];                 // keep record of max 50 players

function PostBeginPlay()
{
	if (!Initialized)
	{
		Initialized = true;
		if (IdleKickTime < 30)
		    IdleKickTime = 30;
		SaveConfig();
        if (bUseSendToSpec)
    		Enable('Tick');
	}
}

function Tick(float DeltaTime)
{
	local int CurrentTime;

    if (!bUseSendToSpec)
        return;

	CurrentTime = Level.TimeSeconds;

	if (CurrentTime > LastCheck)
	{
		CheckForFire();
		LastCheck = CurrentTime;
	}

    SpecialCheck();
}

function SpecialCheck()
{
	local Pawn P;
	local PlayerPawn PP;
	local vector TestBob;
	local int PID;
	local int CurTime;
	TestBob = vect(0,0,0);

	for (P = Level.Pawnlist; P != None; P = P.Nextpawn)
	{
		if ( P.bIsPlayer && P.IsA('PlayerPawn') && !P.PlayerReplicationInfo.bIsABot && !P.PlayerReplicationInfo.bIsSpectator && !Level.Game.bGameEnded )
		{
			PID = P.PlayerReplicationInfo.PlayerID;
			PP=PlayerPawn(P);
			if (P.ViewRotation.Pitch < 32768)
				CurRotation.Pitch = 65536 + P.ViewRotation.Pitch;
			else
				CurRotation.Pitch = P.ViewRotation.Pitch;
			CurTime = Level.TimeSeconds;
			if (P.Health < 1)
			{
				FireRecords[PID].bJustDied=true;
			}
			else
			if (FireRecords[PID].bJustDied && P.Health > 0)
			{
				FireRecords[PID].OldWeapon = P.Weapon;
				FireRecords[PID].bJustDied=false;
				FireRecords[PID].LastRotateTime = CurTime;
				if (P.ViewRotation.Pitch < 32768)
					FireRecords[PID].TestRotation.Pitch = 65536 + P.ViewRotation.Pitch;
				else
					FireRecords[PID].TestRotation.Pitch = P.ViewRotation.Pitch;
			}

			if (FireRecords[PID].bAboutToBeKicked)
			{
				if ((P.bFire!=0 || P.bAltFire!=0 || P.bDuck!=0 || PP.bPressedJump!=False || P.Acceleration!=TestBob || P.Weapon!=FireRecords[PID].OldWeapon || ((CurRotation.Pitch) > (FireRecords[PID].TestRotation.Pitch+150) && (CurRotation.Pitch) < (FireRecords[PID].TestRotation.Pitch-150))) || (P.PlayerReplicationInfo.HasFlag!=None) || (P.PlayerReplicationInfo.bAdmin!=False))
				{
					if (P.Health > 0 || (P.PlayerReplicationInfo.bAdmin!=False) || PP.bPressedJump!=False || P.bFire!=0)
					{
					    FireRecords[PID].bFireLog = false;
					    FireRecords[PID].bAboutToBeKicked = false;
					}
				}
			}

			FireRecords[PID].OldWeapon = P.Weapon;
			CurTime = Level.TimeSeconds;
			if ((CurTime-FireRecords[PID].LastRotateTime) > 5)
			{
				FireRecords[PID].LastRotateTime = CurTime; // record time every 5 seconds
				if (P.ViewRotation.Pitch < 32768)
					FireRecords[PID].TestRotation.Pitch = 65536 + P.ViewRotation.Pitch;
				else
					FireRecords[PID].TestRotation.Pitch = P.ViewRotation.Pitch;
			}
		}
	}
}

function CheckForFire()
{
	local Pawn P;
	local PlayerPawn PP;
	local vector TestBob;
	local int PID;
	local int CurTime;

	TestBob = vect(0,0,0);

	for(P=level.pawnlist; P!=none ; P=P.nextpawn)
	{
		if ( P.bIsPlayer && P.IsA('PlayerPawn') && !P.PlayerReplicationInfo.bIsABot && !P.PlayerReplicationInfo.bIsSpectator && !Level.Game.bGameEnded )
		{
			PP=PlayerPawn(P);
			PID = P.PlayerReplicationInfo.PlayerID; // get player ID
			if (P.ViewRotation.Pitch < 32768)
				CurRotation.Pitch = 65536 + P.ViewRotation.Pitch;
			else
				CurRotation.Pitch = P.ViewRotation.Pitch;
			CurTime = Level.TimeSeconds;
			if (P.Health < 1)
			{
				FireRecords[PID].bJustDied=true;
			}
			else
			if (FireRecords[PID].bJustDied && P.Health > 0)
			{
				FireRecords[PID].OldWeapon = P.Weapon;
				FireRecords[PID].LastRotateTime = CurTime;
				if (P.ViewRotation.Pitch < 32768)
					FireRecords[PID].TestRotation.Pitch = 65536 + P.ViewRotation.Pitch;
				else
					FireRecords[PID].TestRotation.Pitch = P.ViewRotation.Pitch;
			}
			if ((((P.bFire==0) && (P.bAltFire==0) && (P.bDuck==0) && (PP.bPressedJump==False) && (P.Acceleration==TestBob) && (P.Weapon==FireRecords[PID].OldWeapon) && (P.PlayerReplicationInfo.HasFlag==None) && (P.PlayerReplicationInfo.bAdmin==False) && (CurRotation.Pitch) < (FireRecords[PID].TestRotation.Pitch+200) && (CurRotation.Pitch) > (FireRecords[PID].TestRotation.Pitch-200))) || (P.Health < 1 && (P.bFire==0) && (PP.bPressedJump==False) && (P.PlayerReplicationInfo.bAdmin==False)))
			{
				CurTime = Level.TimeSeconds;
				if (FireRecords[PID].bFireLog)
				{
					if ((CurTime-FireRecords[PID].LastFireTime) > IdleKickTime)
					{
						PlayerPawn(P).ClientTravel("?OverrideClass=Botpack.CHSpectator",TRAVEL_Relative, False);
						FireRecords[PID].bFireLog = false;
						BroadcastMessage("<< "$P.PlayerReplicationInfo.PlayerName$" has been moved to Spectator for being idle! >>",True);
					}
					else
					if	((CurTime-FireRecords[PID].LastFireTime) == (IdleKickTime - 3))
						P.ReceiveLocalizedMessage(class'MapVoteIdleMesg', 0);
					else
					if	((CurTime-FireRecords[PID].LastFireTime) == (IdleKickTime - 20))
					{
					    if (!FireRecords[PID].bAboutToBeKicked)
					    {
					        P.ReceiveLocalizedMessage(class'MapVoteIdleMesg', 1);
						}
						FireRecords[PID].bAboutToBeKicked = true;
					}
				}
				else
				{
					FireRecords[PID].bFireLog = true;
					FireRecords[PID].LastFireTime = CurTime;
				}
			}
			else
			if (FireRecords[PID].bFireLog)
			{
				FireRecords[PID].bFireLog = false;
			}
		}
	}
}

defaultproperties
{
      IdleKickTime=220
      CurRotation=(Pitch=0,Yaw=0,Roll=0)
      bUseSendToSpec=True
}
