//============================================================================
// MapVoteMapLoader
//============================================================================
//
class MapVoteMapLoader extends Info;

var MapVoteX MyMut;

var class<GameInfo> MyClass;

var string TotMapList[1200];

var string Prefix;
var string FirstMap;
var string NextMap;
var string TestMap;
var string sMapPaths;

var string DefClas;
var string DefPath;

var int    MaxNumMaps;                // max maps from Mvx
var int    MapCount;

var float  Maptime;

var bool   bStartLoading;
var bool   bInitialized;

function PreBeginPlay()
{
    Super.PreBeginPlay();
    SetTimer(0.0, False);
}

function StartLoadingMaps(string PFix, int gNum, string sGame, string sPath)
{
    local string sTemp;
    local int i;

    MyMut.bMapsLoaded = False;

    for (i=0; i<1200; i++)
         TotMapList[i] = "";

    Maptime = Level.TimeSeconds;
    MapCount = 0;

    sTemp = "";
    Prefix = PFix;

    MyMut.SetMessage(True);

    FirstMap = Level.GetMapName(Prefix, "", 0);
	NextMap = FirstMap;
	LoadMapTypes();
	bStartLoading = true;

	for (i=0; i<MaxNumMaps; i++)
	{
	    if (LoadMapTypes())
	        continue;
	    else
	        break;
	}

	SetTimer(MapCount * 0.01, False);
}

function bool CheckMaps(string sMap, string sPref)
{
    local int i;

    sMap  = Caps(sMap);
    sPref = Caps(sPref);

    if (InStr(sMap, "DM-TUTORIAL") >= 0)
        return false;
    if (InStr(sMap, "MAPVOTEX") >= 0)
        return false;
    if (InStr(sMap, "CTF-") >= 0 && sPref != "CTF-")
        return false;
    if (InStr(sMap, "DOM-") >= 0 && sPref != "DOM-")
        return false;
    if (InStr(sMap, "AS-") >= 0 && sPref != "AS-")
        return false;
    if (InStr(sMap, "DM-") >= 0 && sPref != "DM-")
        return false;
    if (InStr(sMap, "CTFM-") >= 0 && sPref != "CTFM-")
        return false;
    if (InStr(sMap, "CTF4-") >= 0 && sPref != "CTF4-")
        return false;
    if (InStr(sMap, "MH-") >= 0 && sPref != "MH-")
        return false;
    if (InStr(sMap, "MM-") >= 0 && sPref != "MM-")
        return false;
    if (InStr(sMap, "UT-") >= 0 && sPref != "UT-")
        return false;
    if (InStr(sMap, "OWDM-") >= 0 && sPref != "OWDM-")
        return false;
    if (InStr(sMap, "EOL_") >= 0)
        return false;

    i = InStr(sMap, ".UNR");
    if (i >= 0)
        sMap = Left(sMap, i);
    if (sMap == "CITYINTRO" || sMap == "ENTRY" || sMap == "UTCREDITS")
        return false;

    return True;
}

function bool LoadMapTypes()
{
	local string MapName;
	local bool bUse;
	local int z;

	if (FirstMap ~= TestMap || MapCount >= MaxNumMaps )
	{
	    Disable('Tick');
        bStartLoading = false;
        SortMapList();
	    TransferMaps();
	    MyMut.SortMapsAndGames();
	    return False;
	}
	else
	{
		MapName = NextMap;
		bUse = CheckMaps(Mapname, Prefix);
		if (bUse && InStr(Caps(NextMap),"RANDOM MAP") == -1)
		{
  		    z = InStr(Caps(MapName),".UNR");
		    if (z != -1)
			    MapName = Left(MapName,z);

			if (MapName != "")
			{
			    if (TotMapList[MapCount] != MapName)
			    {
			        TotMapList[MapCount] = MapName;
			        MapCount++;
			    }
			}
		}
	    NextMap = Level.GetMapName(Prefix,NextMap,1);
		TestMap = NextMap;
	}
	return True;
}

// Alphatise the maplist
function SortMapList()
{
   local int a, b;
   local string TempMapName;

   // bubble sort the map list
   for(a=0; a<=MapCount-1; a++)    // games load after this
   {
      for(b=a+1; b<=MapCount; b++)
      {
         if (Caps(TotMapList[a]) > Caps(TotMapList[b]))
         {
             TempMapName = TotMapList[a];
             TotMapList[a] = TotMapList[b];
             TotMapList[b] = TempMapName;
         }
      }
   }
}

function TransferMaps()
{
    local int i;

    MyMut.MapCount = MapCount;

    for (i=0; i<MapCount+1; i++)
    {
         MyMut.TotalMapList[i] = TotMapList[i]; // includes prefix
    }
}

event Timer()
{
    MyMut.bMapsLoaded = True;
    MyMut.SetMessage(False);
}

defaultproperties
{
}
