//================================================================================
// MapVotePlayerListBox.
//================================================================================
//
class MapVotePlayerListBox extends UWindowListBox;
//
function Created ()
{
	Super.Created();
	VertSB.Close();
	VertSB=UWindowVScrollbar(CreateWindow(Class'MapVoteScrollBar',WinWidth - 12,0.00,12.00,WinHeight));
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	C.DrawColor.R=255;
	C.DrawColor.G=255;
	C.DrawColor.B=255;
	// top outer line
	DrawStretchedTexture(C,0.00,0.00,WinWidth,1.00,Texture'WhiteTexture');
	// left outer line
	DrawStretchedTexture(C,0.00,0.00,1.00,WinHeight - 1,Texture'WhiteTexture');
	// rank divider line
	DrawStretchedTexture(C,20.00,0.00,1.00,WinHeight - 1,Texture'WhiteTexture');
	// MapName divider line
	DrawStretchedTexture(C,145.00,0.00,1.00,WinHeight - 1,Texture'WhiteTexture');
	// bottom line
	DrawStretchedTexture(C,0.00,WinHeight - 1,WinWidth,1.00,Texture'WhiteTexture');

	Super.Paint(C,MouseX,MouseY);
}

function DrawItem (Canvas C, UWindowList Item, float X, float Y, float W, float H)
{
	local string sTemp;
	local int i;

	C.DrawColor.R=255;
	C.DrawColor.G=255;
	C.DrawColor.B=0;

	C.Font=Root.Fonts[0];
	sTemp = MapVotePlayerListItem(Item).PlayerName;
	i = int(Left(sTemp, 1));                         // 0,1,2 team color no used
	sTemp = Mid(sTemp, 1);
	if (Len(sTemp) > 25)
	    sTemp = Left(sTemp, 25);
	ClipText(C, X + 25,  Y, sTemp);
}

function KeyDown (int Key, float X, float Y)
{
	local PlayerPawn P;

	P = GetPlayerOwner();

	if (Key == P.EInputKey.IK_MouseWheelDown || Key == P.EInputKey.IK_Down)
	{
		if ( (SelectedItem != None) && (SelectedItem.Next != None) )
		{
			SetSelectedItem(UWindowListBoxItem(SelectedItem.Next));
			MakeSelectedVisible();
		}
	}
	if (Key == P.EInputKey.IK_MouseWheelUp || Key == P.EInputKey.IK_Up)
	{
		if ( (SelectedItem != None) && (SelectedItem.Prev != None) && (SelectedItem.Sentinel != SelectedItem.Prev) )
		{
			SetSelectedItem(UWindowListBoxItem(SelectedItem.Prev));
			MakeSelectedVisible();
		}
	}
	ParentWindow.KeyDown(Key,X,Y);
}
//
defaultproperties
{
    ItemHeight=13.00
    ListClass=Class'MapVotePlayerListItem'
}