//================================================================================
// MapVotePosition
//================================================================================
//
class MapVotePosition extends Info Config(MapVoteX);

var() config int   VotePositionX;
var() config int   VotePositionY;
var() config int   GradientStyle;
var() config float ScreenSize;
var() config bool  bHookFireDone;
var() config Color BackGroundColor;

function PreBeginPlay ()
{
    Super.PreBeginPlay();

    CheckWindowPos();
	SaveConfig();
}

function CheckWindowPos() // in case user fiddles
{
	if (VotePositionX < 0)
	    VotePositionX = 0;
	if (VotePositionY < 0)
	    VotePositionY = 0;

	if (VotePositionX > 100)
	    VotePositionX = 100;
	if (VotePositionY > 100)
	    VotePositionY = 100;

	if (GradientStyle < 0)
	    GradientStyle = 0;
	if (GradientStyle > 1)
	    GradientStyle = 1;
}

function SetStyle(int x)
{
    GradientStyle = x;
    SaveConfig();
}

simulated function SetBackGround(color BG)
{
    BackGroundColor = BG;
    SaveConfig();
}

function Close(optional bool bByParent)
{
    SaveConfig();
}

function SetHook(bool bH)
{
    bHookFireDone = bH;
    SaveConfig();
}

defaultproperties
{
    VotePositionX=50
    VotePositionY=50
    GradientStyle=0
    ScreenSize=1.00000
    BackGroundColor=(R=10,G=27,B=248,A=255)
}
