//================================================================================
// MapVoteServerActors
//================================================================================
//
class MapVoteServerActors extends Info;

var MapVoteX MyMut;

var MapVoteDefaultActors   MVDA;
var MapVoteGameAliases     MVGA;

var string DefaultAct[100];                      // packs from 100 MVDA
var string GameActors[100];                      // packs from cusgames packs=
var string gmActors;                             // together must <= 200
var string UnloadActors;                         // actors to remove from gmActors
                                                 // total 200 def + game actors
var bool bInitialized;

function PostBeginPlay()
{
	if (!bInitialized)
	{
        if (MVGA == None)
            MVGA = Spawn(class'MapVoteGameAliases');
	    bInitialized = true;
    }
}

function bool CheckActor(string sAct)
{
    local int i;

    i = InStr(sAct, ">");
    if (i > 1)
        return true;                             // true so as not to store

    for (i=0; i<100; i++)
    {
        if (DefaultAct[i] == "")
            break;
        if (DefaultAct[i] == sAct)
            return true;
    }
    return false;
}

function CheckDefaultAliases()
{
     local string sDefItems[100];
     local string sTemp;
     local int i, j, k, x;

     for (i=0; i<100; i++)                       // clear first
         sDefItems[i] = "";

     x = 0;
     for (i=0; i<100; i++)                       // 100 from MVDA
     {
         sTemp = DefaultAct[i];
         if (Left(sTemp, 1) == "<")
         {
             if (x >= 100)
                 break;
             sTemp = MVGA.CheckForAlias(sTemp);
             for (k=0; k<100; k++)                // max per alias
             {
                 if (x >= 100)
                     break;
                 j = InStr(sTemp, ",");
                 if (j >= 0)
                 {
                     if (sTemp == "")
                         break;
                     sDefItems[x] = Left(sTemp, j);
                     x++;
                     sTemp = Mid(sTemp, j+1);
                 }
                 else
                 {
                     break;
                 }
             }
         }
         else
         {
             if (sTemp == "" || x >= 100)
                 break;
             sDefItems[x] = sTemp;
             x++;
         }
     }

     for (i=0; i<100; i++)
         DefaultAct[i] = "";

     for (i=0; i<100; i++)
     {
         sTemp = sDefItems[i];
         if (sTemp == "")
             break;
         DefaultAct[i] = sTemp;
     }
}

function WriteServerActors(int iGame)
{
    local string sTemp, sAct, sTotal, sAlis;
    local int i, j, x;
    local bool bFound;

    if (MVDA == None)
        MVDA = Spawn(class'MapVoteDefaultActors');

    if (MVDA.DefaultActor[0] != "")
        MVDA.RestoreDefaultActors();
    else
        MVDA.GetDefaultActors();

    if (MVDA.DefaultActor[0] == "")
        return;

    for (i=0; i<100; i++)                        // MVDA only has 100
         DefaultAct[i] = MVDA.DefaultActor[i];

    CheckDefaultAliases();                       // check DefaultAct[i] for aliases

    sTemp = gmActors;                            // this games ServerActors
    sTotal = "";
    UnloadActors = "";

    if (Right(sTemp, 1) != ",")
        sTemp = sTemp$",";

    for (i=0; i<100; i++)                        // search for alias
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;

        sAlis = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);

        if (Left(sAlis, 1) != ";")               // remarked out
        {
            j = InStr(sAlis, "<");
            if (j != -1)                             // is this an alias ?
            {
               bFound = false;
               for (x=0; x<100; x++)
               {
                   sAct = MVGA.CheckForAlias(sAlis);
                   if (sAct != sAlis)
                   {
                      sAlis = sAct;
                      bFound = true;
                      break;
                   }
               }
               if (!bFound)
                   sAlis = "";
            }

            if (sAlis != "")
            {
                sTotal = sTotal$sAlis;
                if (Right(sTotal, 1) != ",")
                    sTotal = sTotal$",";
            }
        }
    }

    if (Right(sTotal, 1) != ",")
        sTotal = sTotal$",";

    sTemp  = sTotal;
    sTotal = "";
    for (i=0; i<100; i++)                        // search for "-"
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;

        sAlis = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);

        j = InStr(sAlis, "-");
        if (j != -1)
        {
            UnloadActors = UnloadActors$Mid(sAlis, 1)$",";
            sAlis = "";
        }

        if (sAlis != "")
        {
            sTotal = sTotal$sAlis;
            if (Right(sTotal, 1) != ",")
                sTotal = sTotal$",";
        }
    }

    if (Right(sTotal, 1) != ",")
        sTotal = sTotal$",";

    x = 0;
    if (Len(sTotal) > 3)
    {
       for (i=0; i<100; i++)
       {
           j = InStr(sTotal, ",");
           if (j == -1)
              break;
           sAct  = Left(sTotal, j);
           sTotal = Mid(sTotal, j+1);
		   if (sAct != "")
		   {
              if (CheckActor(sAct) == false)
              {
                  GameActors[x] = sAct;
                  x++;
              }
           }
       }
    }

    x = 0;
    sTemp = "(";

    for (i=0; i<100; i++)                        // default actors
    {
        if (DefaultAct[i] == "")
           break;
        if (InStr(DefaultAct[i], ";") < 0)
        {
            sAct  = Caps(DefaultAct[i]);
            j = InStr(Caps(UnloadActors), sAct);
            if (j < 0)
            {
                j = InStr(DefaultAct[i], "\"");
                if (j >= 0)
                    sTemp = sTemp$DefaultAct[i]$",";
                else
                    sTemp = sTemp$"\""$DefaultAct[i]$"\",";
                x++;
            }
        }
    }

    for (i=0; i<100; i++)                        // customegame actors
    {
        if (GameActors[i] == "")
           break;
        sTemp = sTemp$"\""$GameActors[i]$"\",";
        x++;
        if (x >= 200)
            break;
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";

    DebugLog("Set  ServerActors = ("$x$") "$sTemp);
    Level.ConsoleCommand("set Engine.GameEngine ServerActors "$sTemp);
}

function DebugLog (string Msg)
{
	if ( MyMut.default.bDebugMode )
	{
		Log("**** " $Msg);
	}
}

defaultproperties
{
}
