//================================================================================
// MapVoteServerPackages
//================================================================================
//
class MapVoteServerPackages extends Info;
//
var MapVoteX MyMut;

var MapVoteDefaultPackages MVDP;
var MapVoteGameAliases     MVGA;

var string DefaultPacks[200];                    // packs from 100 MVDP + aliases + game packages
var string GamePackages[100];                    // packs from custgames + aliases
var string gmPackages;                           // together must <= 100
var string UnloadPacks;                          // packages to remove from gmPackages
                                                 // total 300 def + game packages

var bool bInitialized;

function PostBeginPlay()
{
	if (!bInitialized)
	{
        if (MVGA == None)
            MVGA = Spawn(class'MapVoteGameAliases');
	    bInitialized = true;
    }
}

function bool CheckPackage(string sPak)          // check if defpacks contains -sPak from cus game
{
    local int i;

    i = InStr(sPak, ">");
    if (i > 1)
        return true;                             // true so as not to store

    for (i=0; i<200; i++)
    {
        if (DefaultPacks[i] == "")
            break;
        if (DefaultPacks[i] == sPak)
            return true;
    }
    return false;
}

function CheckDefaultAliases()
{
     local string sDefItems[200];
     local string sTemp;
     local int i, j, k, x;

     for (i=0; i<200; i++)                       // clear first
         sDefItems[i] = "";

     x = 0;
     for (i=0; i<100; i++)                       // 100 from MVDP
     {
         sTemp = DefaultPacks[i];
         if (Left(sTemp, 1) == "<")
         {
             if (x >= 200)
                 break;
             sTemp = MVGA.CheckForAlias(sTemp);
             for (k=0; k<100; k++)                // max per alias
             {
                 if (x >= 200)
                     break;
                 j = InStr(sTemp, ",");
                 if (j >= 0)
                 {
                     if (sTemp == "")
                         break;
                     sDefItems[x] = Left(sTemp, j);
                     x++;
                     sTemp = Mid(sTemp, j+1);
                 }
                 else
                 {
                     break;
                 }
             }
         }
         else
         {
             if (sTemp == "" || x >= 200)
                 break;
             sDefItems[x] = sTemp;
             x++;
         }
     }

     for (i=0; i<200; i++)
         DefaultPacks[i] = "";

     for (i=0; i<200; i++)
     {
         sTemp = sDefItems[i];
         if (sTemp == "")
             break;
         DefaultPacks[i] = sTemp;
     }
}

function WriteServerPackages(int iGame)
{
    local string sPack, sTemp, sTotal, sAlis;
    local int i, j, x;
    local bool bFound;

    if (MVDP == None)
        MVDP = Spawn(class'MapVoteDefaultPackages');

    if (MVDP.DefaultPackage[0] != "")
        MVDP.RestoreDefaultPackages();
    else
	    MVDP.GetDefaultPackages();

    if (MVDP.DefaultPackage[0] == "")
        return;

    for (i=0; i<100; i++)                        // MVDP only has 100
         DefaultPacks[i] = MVDP.DefaultPackage[i];

    CheckDefaultAliases();                       // check DefaultPacks[i] for aliases

    sTemp  = gmPackages;                         // this games ServerPackages
    sTotal = "";
    UnloadPacks = "";

    if (Right(sTemp, 1) != ",")
        sTemp = sTemp$",";

    for (i=0; i<100; i++)                        // search for alias
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;

        sAlis = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);                 // complete string

        if (Left(sAlis, 1) != ";")               // remarked out
        {
            j = InStr(sAlis, "<");
            if (j != -1)                         // is this an alias ?
            {
               bFound = false;
               for (x=0; x<100; x++)
               {
                   sPack = MVGA.CheckForAlias(sAlis);
                   if (sPack != sAlis)
                   {
                      sAlis = sPack;
                      bFound = true;
                      break;
                   }
               }
               if (!bFound)
                   sAlis = "";
            }

            if (sAlis != "")
            {
                sTotal = sTotal$sAlis;
                if (Right(sTotal, 1) != ",")
                    sTotal = sTotal$",";
            }
        }
    }

    if (Right(sTotal, 1) != ",")
        sTotal = sTotal$",";

    sTemp  = sTotal;
    sTotal = "";
    for (i=0; i<100; i++)                        // search for "-"
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;

        sAlis = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);

        j = InStr(sAlis, "-");
        if (j != -1)
        {
            UnloadPacks = UnloadPacks$Mid(sAlis, 1)$",";
            sAlis = "";
        }

        if (sAlis != "")
        {
            sTotal = sTotal$sAlis;
            if (Right(sTotal, 1) != ",")
                sTotal = sTotal$",";
        }
    }

    if (Right(sTotal, 1) != ",")
        sTotal = sTotal$",";

    x = 0;
    if (Len(sTotal) > 3)
    {
       for (i=0; i<100; i++)
       {
           j = InStr(sTotal, ",");
           if (j == -1)
              break;
           sPack = Left(sTotal, j);
           sTotal = Mid(sTotal, j+1);
		   if (sPack != "")
		   {
		      if (CheckPackage(sPack) == false)
		      {
                  GamePackages[x] = sPack;
                  x++;
              }
           }
       }
    }

    x = 0;
    sTemp = "(";

    for (i=0; i<200; i++)                        // 200 default packages
    {
        if (DefaultPacks[i] == "")
           break;
        if (InStr(DefaultPacks[i], ";") < 0)
        {
            sPack = Caps(DefaultPacks[i]);
            j = InStr(Caps(UnloadPacks), sPack);
            if (j < 0)
            {
                j = InStr(DefaultPacks[i], "\"");
                if (j >= 0)
                    sTemp = sTemp$DefaultPacks[i]$",";
                else
                    sTemp = sTemp$"\""$DefaultPacks[i]$"\",";
                x++;
            }
        }
    }

    for (i=0; i<100; i++)                        // 100 custom game packages
    {
        if (GamePackages[i] == "")
           break;
        sTemp = sTemp$"\""$GamePackages[i]$"\",";
        x++;
        if (x >= 300)
            break;
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";

    DebugLog("Set  ServerPackages = ("$x$") "$sTemp);
    Level.ConsoleCommand("set Engine.GameEngine ServerPackages "$sTemp);
}

function DebugLog (string Msg)
{
	if ( MyMut.default.bDebugMode )
	{
		Log("**** " $Msg);
	}
}

defaultproperties
{
}
