//================================================================================
// MapVoteStatusListBox.
//================================================================================
//
class MapVoteStatusListBox extends UWindowListBox;
//
function Created ()
{
	Super.Created();
	VertSB.Close();
	VertSB=UWindowVScrollbar(CreateWindow(Class'MapVoteScrollBar',WinWidth - 12,0.00,12.00,WinHeight));
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	C.DrawColor.R=255;
	C.DrawColor.G=255;
	C.DrawColor.B=255;
	// top outer line
	DrawStretchedTexture(C,0.00,0.00,WinWidth,1.00,Texture'WhiteTexture');
	// left outer line
	DrawStretchedTexture(C,0.00,0.00,1.00,WinHeight - 1,Texture'WhiteTexture');
	// rank divider line
	DrawStretchedTexture(C,20.00,0.00,1.00,WinHeight - 1,Texture'WhiteTexture');
	// MapName divider line
	DrawStretchedTexture(C,145.00,0.00,1.00,WinHeight - 1,Texture'WhiteTexture');
	// bottom line
	DrawStretchedTexture(C,0.00,WinHeight - 1,WinWidth,1.00,Texture'WhiteTexture');

	Super.Paint(C,MouseX,MouseY);
}

function DrawItem (Canvas C, UWindowList Item, float X, float Y, float W, float H)
{
	local string sTemp;
	local int Count;

	if ( MapVoteStatusListItem(Item).bSelected )
	{
		//draw blue background
		C.DrawColor.R=0;
		C.DrawColor.G=0;
		C.DrawColor.B=128;
		DrawStretchedTexture(C,X,Y + 1,W,H - 2,Texture'WhiteTexture');
        //draw white outer border lines
		C.DrawColor.R=255;
		C.DrawColor.G=255;
		C.DrawColor.B=255;
		// bottom line
		DrawStretchedTexture(C,X,Y + H - 1,W,1.00,Texture'WhiteTexture');
		// rank divider line
		DrawStretchedTexture(C,20.00,Y,1.00,H,Texture'WhiteTexture');
		// left line
		DrawStretchedTexture(C,0.00,Y,1.00,H,Texture'WhiteTexture');
		// MapName divider line
		DrawStretchedTexture(C,145.00,Y,1.00,H,Texture'WhiteTexture');
	}
	else
	{
		C.DrawColor.R=255;
		C.DrawColor.G=255;
		C.DrawColor.B=255;
		DrawStretchedTexture(C,X,Y + H - 1,W,1.00,Texture'WhiteTexture');
	}
	C.Font=Root.Fonts[0];
	ClipText(C, X + 5,   Y, string(MapVoteStatusListItem(Item).rank));
	sTemp = MapVoteStatusListItem(Item).MapName;
	if (Len(sTemp) > 25)
	    sTemp = Left(sTemp, 25);
	ClipText(C, X + 25,  Y, sTemp);
	Count = int(MapVoteStatusListItem(Item).VoteCount);
	ClipText(C, X + 150, Y, string(Count));
}

function SelectMap(string MapName)
{
   local string sTemp;
   local MapVoteStatusListItem MapItem;

   for (MapItem = MapVoteStatusListItem(Items); MapItem != None; MapItem = MapVoteStatusListItem(MapItem.Next) )
   {
      sTemp = MapItem.MapName;
      if (Left(sTemp, 4) == "[GG]")
         sTemp = Mid(sTemp, 4);
      if (MapName ~= sTemp)
      {
         SetSelectedItem(MapItem);
         MakeSelectedVisible();
         break;
      }
   }
}

function DoubleClickItem (UWindowListBoxItem i)
{
	UWindowDialogClientWindow(ParentWindow).Notify(self, 11);
}
//
defaultproperties
{
    ItemHeight=13.00
    ListClass=Class'MapVoteStatusListItem'
}
