//================================================================================
// MapVoteTabWindow - Client
//================================================================================
//
class MapVoteTabWindow extends UMenuDialogClientWindow;

#exec texture IMPORT NAME=Grad1  File=Textures\style1.pcx  GROUP=Mapvote  MIPS=Off   //MapVoteWindowInfo MapVoteWindowVote
#exec texture IMPORT NAME=Grad2  File=Textures\style2.pcx  GROUP=Mapvote  MIPS=Off   //MapVoteWindowInfo MapVoteWindowVote
#exec texture IMPORT NAME=mvxw   File=Textures\mvxw1.pcx   GROUP=Mapvote  MIPS=Off   //MapVoteWelcome
#exec texture IMPORT NAME=mvx1   File=Textures\mvxtx.pcx   GROUP=Mapvote  MIPS=Off   //MapVoteWindowInfo
#exec texture IMPORT NAME=boxbg  File=Textures\boxbg1.pcx  GROUP=Mapvote  MIPS=Off   //MapVoteListBox
#exec texture IMPORT NAME=CopyR  File=Textures\copyr.pcx   GROUP=Mapvote  MIPS=Off   //MapVoteListBox

var MapVotePosition MVPOS;                                 // needed to open the window
var MapVoteGRI      MVGRI;
var UWindowWindow   TheWindow;

var int MapsOnlyCount;
var int MaxNumMaps;

var UMenuPageControl     Pages;
var MapVoteWindowVote    MapWindow;
var MapVoteWindowWelcome WelcomeWindow;
var MapVoteWindowTops    TopWindow;
var MapVoteWindowInfo    InfoWindow;

var MapVoteWindowAdmin   AdminWindow;
var MapVoteWindowMess    MessWindow;

var string PrevSelectedMap;
var string PrevSelectedPlayer;
var string MapPref;
var string sOldName;
var string sCode;

var int  iWebDone;
var int  iStuff;
var int  iTock;

var bool bDone;
var bool bAdminMesg;
var bool bWelcomeMenu;
var bool bGameHasEnded;
var bool bAdmin;
var bool bMidGame;
var bool bMapsOnly;
var bool bNoBots;
var bool bDebugMode;
var bool bOK;

function Created ()
{
	Super.Created();

    iTock = 1000;
	iWebDone = 0;
	iStuff = 0;
	bDone = false;

    if (MVGRI == none)
    {
        foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
        break;
    }

    if (MVPOS == None)
        MVPOS = GetPlayerOwner().Spawn(class'MapVotePosition');  // needed here to spawn the class
}

function Tick(float DeltaTime)
{
    Super.Tick(DeltaTime);

    if (iTock > 0)
    {
        iTock--;
        if (iTock == 0 && bOK && MapWindow.LastMapCount < MVGRI.LoadedMapNum-10)
        {
            iTock = 20;
            LoadTheMapsOnly();
        }
    }
}

function SetupMapWindow(string sDefgame, int iGames, bool bDebug, bool bOnlymaps, string sCod, int iCount, string Vers, int iAdmin, int iWelcome,
                        int iUse, int iEndGame, int iShowFirst, int iMaps, int iMidGame, string Pref, int PlayerNum)
{                                                                   //
	local UWindowPageControlPage PageControl;
	local Playerpawn P;

	P = GetPlayerOwner();

    if (GetPlayerOwner().bAdmin)
        bAdmin = GetPlayerOwner().bAdmin;
    else
        bAdmin = GetPlayerOwner().PlayerReplicationInfo.bAdmin;

    PlayerNum = PlayerNum;
    bMapsOnly = bOnlyMaps;
    MapsOnlyCount = iCount;
    bDebugMode = bDebug;
    sCode = sCod;

    MapPref = Pref;

    if (P != None)
    {
        if (bAdmin == false)
        {
            bAdmin = P.PlayerReplicationInfo.bAdmin || P.bAdmin;
        }
    }

    bWelcomeMenu = bool(iWelcome);
    bGameHasEnded = bool(iEndGame);
    bMidGame = bool(iMidGame);

	Pages = UMenuPageControl(CreateWindow(Class'MapVotePageControl',0.00,0.00,WinWidth,WinHeight));
	Pages.SetMultiLine(True);   // kills the <> on the right edge :)

    if ( bGameHasEnded )
    {
       if ( bWelcomeMenu && iShowFirst == 1 )
       {
	      PageControl = Pages.AddPage("Welcome",Class'MapVoteWindowWelcome');
	      WelcomeWindow = MapVoteWindowWelcome(PageControl.Page);
	      WelcomeWindow.SetupLinks();
	   }

       PageControl = Pages.AddPage("Voting",Class'MapVoteWindowVote');
       MapWindow = MapVoteWindowVote(PageControl.Page);
       MapWindow.bMapsOnly = bMapsOnly;
       MapWindow.sCode = sCode;
       MapWindow.MapsOnlyCount = MapsOnlyCount;
       MapWindow.bDebugMode = bDebugMode;
       MapWindow.PlayerNum = PlayerNum;
       MapWindow.bNoBots = True;
       MapWindow.NumMaps = iMaps;
       MapWindow.NumGams = iGames;

       if ( bWelcomeMenu && iShowFirst == 0 )
       {
          PageControl = Pages.AddPage("Welcome",Class'MapVoteWindowWelcome');
	      WelcomeWindow = MapVoteWindowWelcome(PageControl.Page);
	      WelcomeWindow.SetupLinks();
	   }

       if (!bMapsOnly)
       {
           PageControl = Pages.AddPage("Info",Class'MapVoteWindowInfo');
           InfoWindow = MapVoteWindowInfo(PageControl.Page);
           if (InfoWindow != None)
           {
               InfoWindow.bAdmin = bAdmin;
               InfoWindow.Version = Vers;
               InfoWindow.sCode = sCode;
           }

           PageControl = Pages.AddPage("Top Stuff",Class'MapVoteWindowTops');
           TopWindow = MapVoteWindowTops(PageControl.Page);
           if (InfoWindow != None)
           {
               TopWindow.sCode = sCode;
               TopWindow.LoadGameMaps();
           }

           if (bAdmin)
           {
               if (bAdmin && InfoWindow != None)
               {
                   InfoWindow.bAdmin = true;
                   InfoWindow.SetupAdminStuff();
	           }

	           PageControl = Pages.AddPage("Configs",Class'MapVoteWindowAdmin');
	           AdminWindow = MapVoteWindowAdmin(PageControl.Page);
	           AdminWindow.sCode = sCode;

               PageControl = Pages.AddPage("Messages",Class'MapVoteWindowMess');
               MessWindow = MapVoteWindowMess(PageControl.Page);
               MessWindow.sCode = sCode;
	       }
       }

       LoadMaps();
       if (bAdmin)
           InfoWindow.SetDefGame(sDefgame);
       return;
    }

    if ( bWelcomeMenu && iShowFirst == 1 )
    {
	   PageControl = Pages.AddPage("Welcome",Class'MapVoteWindowWelcome');
	   WelcomeWindow = MapVoteWindowWelcome(PageControl.Page);
	   WelcomeWindow.SetupLinks();
	}

    if (iMidGame == 1 || bAdmin)
    {
	   PageControl = Pages.AddPage("Voting",Class'MapVoteWindowVote');
	   MapWindow = MapVoteWindowVote(PageControl.Page);
	   MapWindow.bDebugMode = bDebugMode;
	   MapWindow.bMapsOnly = bMapsOnly;
	   MapWindow.PlayerNum = PlayerNum;
	   MapWindow.bNoBots = bNoBots;
	   MapWindow.sCode = sCode;
       MapWindow.NumMaps = iMaps;
       MapWindow.NumGams = iGames;
	}

    if ( bWelcomeMenu && iShowFirst == 0 )
    {
       PageControl = Pages.AddPage("Welcome",Class'MapVoteWindowWelcome');
       WelcomeWindow = MapVoteWindowWelcome(PageControl.Page);
       WelcomeWindow.SetupLinks();
    }

    PageControl = Pages.AddPage("Top Stuff",Class'MapVoteWindowTops');
    TopWindow = MapVoteWindowTops(PageControl.Page);
    TopWindow.sCode = sCode;
    TopWindow.LoadGameMaps();

    PageControl = Pages.AddPage("Info",Class'MapVoteWindowInfo');
    InfoWindow = MapVoteWindowInfo(PageControl.Page);
    InfoWindow.bAdmin = bAdmin;
    InfoWindow.Version = Vers;
    InfoWindow.sCode = sCod;

    if (bAdmin)
    {
       if (bAdmin)
       {
           InfoWindow.bAdmin = true;
           InfoWindow.SetupAdminStuff();
	   }

	   PageControl = Pages.AddPage("Admin",Class'MapVoteWindowAdmin');
	   AdminWindow = MapVoteWindowAdmin(PageControl.Page);
	   AdminWindow.sCode = sCode;

       PageControl = Pages.AddPage("Messages",Class'MapVoteWindowMess');
       MessWindow = MapVoteWindowMess(PageControl.Page);
       MessWindow.sCode = sCode;
	}

    if (MapWindow != None)
        LoadMaps();
    if (bAdmin)
        InfoWindow.SetDefGame(sDefgame);
}

function LoadMaps()
{
    local string sTemp, GameMap;
    local int i, j, k;

    if (bMapsOnly)
    {
        LoadMapsOnly();
        return;
    }

    if ( MVGRI == none )
    {
       foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
       break;
    }

    if (MapPref == "")
        MapPref = MVGRI.GameStuff2[203];

    MaxNumMaps = MVGRI.MaxNumMaps;

    ClearList(1);    // maplist
    ClearList(2);    // gamelist

    j = 0;
    for (i=1; i<201; i++)
    {
		sTemp = MVGRI.GameStuff1[i];
		if (sTemp != "")
		{
		   GameMap = "";
           AddMapName(2, sTemp, j, 0);
           k = 0;
	       if (Caps(Mid(sTemp, 3)) == Caps(MVGRI.GameStuff2[202])) // MVGameName
	           k = 1;
	       GameMap = MVGRI.GameStuff2[j+1];
	       AddMapName(3, GameMap, j, k);
	       j++;
        }
        if (i > 2 && sTemp == "")
            break;
    }

    MapWindow.LastMapCount = 0;
    if (GetPlayerOwner().Level.TimeSeconds < 7)
    {
        iTock = 20;
        bOK = True;
    }
    else
    {
        LoadTheMapsOnly();
    }
}

function LoadTheMapsOnly()
{
    local string sTemp;
    local int i, j, K;

    if (MapPref == "")
        MapPref = MVGRI.GameStuff2[203];

    j = 0;
    K = MapWindow.LastMapCount;

    for (i=K; i<MaxNumMaps+1; i++)
    {

        if (i < 256)
		    sTemp = MVGRI.ListedMaps1[i];
		else
		if (i < 512)
		    sTemp = MVGRI.ListedMaps2[i-256];
		else
		if (i < 768)
		    sTemp = MVGRI.ListedMaps3[i-512];
		else
		if (i < 1024)
		    sTemp = MVGRI.ListedMaps4[i-768];

		if (sTemp != "")
		{
		    if (bMapsOnly)
		    {
		        if (Left(sTemp, 4) != "[GG]")
		        {
		            AddMapName(1, sTemp, 0, 0);
		            MapWindow.LastMapCount++;
		            if (i == 0)
		            {
	                    if ( Left(sTemp,4) ~= "[XX]" )
		                    sTemp = "[XX]"$MapPref$Mid(sTemp,4);
	                    else
	                        sTemp = MapPref$sTemp;
		                MapWindow.SetMap(MapWindow.CheckMapname(sTemp));
		            }
		        }
		    }
		    else
		    if (Left(sTemp, 4) != "[GG]")
		    {
		        AddMapName(1, sTemp, 0, 0);
		        MapWindow.LastMapCount++;
		    }
		}
		else
		{
		   j++;
   		   if (j > 2)
		      break;
		}
    }
}

function LoadMapsOnly()
{
    if ( MVGRI == none )
    {
       foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
       break;
    }

    if (MapPref == "")
        MapPref = MVGRI.MapPref;

    MaxNumMaps = MVGRI.MaxNumMaps;

    ClearList(1);
    ClearList(2);

    MapWindow.LastMapCount = 0;
    LoadTheMapsOnly();
    iTock = 20;
    bOK = True;
}

function AddMapName(int listNum, string MapName, int x, optional int k)
{
	local MapVoteUMenuList MVUM;

	if ( listNum == 1 ) // Maps
	{
		MVUM = MapVoteUMenuList(MapWindow.MapListBox.Items.Append(Class'MapVoteUMenuList'));
	    if ( Left(MapName,4) ~= "[XX]" )
		    MapName = "[XX]"$MapPref$Mid(MapName,4);
	    else
	    if (k != 2)
	        MapName = MapPref$MapName;
	}
    else
	if ( listNum == 2 ) // Games - [GG]Capture the Flag
	{
		MVUM = MapVoteUMenuList(MapWindow.GameListBox.Items.Append(Class'MapVoteUMenuList'));
		MapWindow.GameList[x] = MapName;
		MVUM.GameName = MapName;
		if (!bMapsOnly)
		{
		    if (bAdmin && InfoWindow != None)
		        InfoWindow.DefGameCombo.AddItem(Mid(MapName, 4));
		}
	}
    else
	if ( listNum == 3 ) // GameMaps
	{
		MapWindow.GameMaps[x] = MapName;
		if (k == 1)
		   MapWindow.SetMap(MapWindow.CheckMapname(MapName));
		return;
	}
	if (MVUM == None)
	    MVUM = MapVoteUMenuList(MapWindow.MapListBox.Items.Append(Class'MapVoteUMenuList'));
	MVUM.MapName = MapName;
}

function AddMessage(string MesgName, int iNmr)  // client side
{
	local string sTemp;

    if (iNmr < 10)
        sTemp = "0";

    sTemp = sTemp$iNmr$"  "$MesgName;
    MessWindow.TheTextArea.AddText(sTemp);
    MessWindow.Messages[iNmr] = sTemp;
}

function SetupMenu(string sCod, int iAdm, string Stuff, string svrName, string svrPort, string svrIP)
{
    if (iAdm == 0 && bAdminMesg)
        return;

    if (iAdm == 1 && iStuff < 10)
    {
        if (AdminWindow != None)
        {
            AdminWindow.ReceiveStuff(Stuff);
            AdminWindow.sCode = sCod;
            iStuff++;
        }
    }

    InfoWindow.BookButton.bDisabled = True;

    if (svrName == "")
        svrName = "Another Mvx Server";

    if (svrIP != "" && svrPort != "")
    {
        if (iAdm == 0)
            InfoWindow.BookButton.bDisabled = False;
        InfoWindow.ServerName = svrName;
        InfoWindow.ServerPort = svrPort;
        InfoWindow.ServerIP   = svrIP;
    }

    if ( bGameHasEnded || (!bGameHasEnded && bMidGame) || iAdm == 1 )
    {
       MapWindow.sCode = sCod;
    }

}
                    //    Stretch       Logoname      Soundname    Prefix
function SetupWelcome(string Stretch, string sLogo, string sSound, string Prefix)
{
    if (WelcomeWindow != None && iWebDone < 3)
    {
        WelcomeWindow.bStretch      = false;
        if (Stretch == "1")
            WelcomeWindow.bStretch  = True;

        WelcomeWindow.MenuLogoName     = sLogo;
        WelcomeWindow.MenuSoundName    = sSound;
        WelcomeWindow.SetupCombo();

        iWebDone++;
    }
}

function ClearList(int listNum)
{
    if (!bDone)
    {
        bDone = true;
        MapWindow.bMapsOnly = bMapsOnly;
        MapWindow.MapsOnlyCount = MapsOnlyCount;
        MapWindow.SetupClientWindow();
    }

	if ( listNum == 1 )
		MapWindow.MapListBox.Items.Clear();
	else
    if ( listNum == 2 )
		MapWindow.GameListBox.Items.Clear();
}

function ClearMesgs()
{
    MessWindow.TheTextArea.Clear();
}

function AddPlayerName (string PlayerName)
{
	local MapVotePlayerListItem i;
	local UWindowList Item;

	Item = MapWindow.ListVotePlayer.Items;
	for (Item = MapWindow.ListVotePlayer.Items; Item != None; Item=Item.Next)
	{
		if ( MapVotePlayerListItem(Item).PlayerName ~= PlayerName )
			return;
	}

	i = MapVotePlayerListItem(MapWindow.ListVotePlayer.Items.Append(Class'MapVotePlayerListItem'));
	i.PlayerName = PlayerName;
}

simulated function UpdateMapVoteResults (string Text, int i)
{
	local UWindowList Item;
	local string sTemp, MapName;
	local int j, pos;
	local float C;

    if (Left(Text, 11) == "Please wait")
    {
        MapWindow.sTitle = Text;
        return;
    }

	if ( Text == "Clear" )
	{
		if ( MapWindow.ListVoteStatus.SelectedItem != None )
		{
			PrevSelectedMap = MapVoteStatusListItem(MapWindow.ListVoteStatus.SelectedItem).MapName;
		}
		MapWindow.ListVoteStatus.Items.Clear();
		return;
	}
	j = -1;
	pos = InStr(Text, ",");
	if ( pos > 0 )
	{
		MapName = Left(Text, pos);
		C = float(Mid(Text, pos + 1));
	}

    if (Left(MapName, 4) == "[RR]")
    {
        sTemp = MapName;
        MapName = "Random Map";
    }

    if (Left(MapName, 4) == "[RG]")
    {
        sTemp = MapName;
        MapName = "Random Game";
    }

    // check to see if MapName is already in the list
    for (Item = MapWindow.ListVoteStatus.Items; Item != None; Item = Item.Next)
    {
        if (MapVoteStatusListItem(Item).MapName ~= MapName)
        {
            MapVoteStatusListItem(Item).Rank = i + 1;
            MapVoteStatusListItem(Item).VoteCount = c;
            return;
        }
    }

	Item = MapVoteStatusListItem(MapWindow.ListVoteStatus.Items.Append(Class'MapVoteStatusListItem'));
	MapVoteStatusListItem(Item).rank = i + 1;
	MapVoteStatusListItem(Item).MapName = MapName;
	MapVoteStatusListItem(Item).VoteCount = C;
	if ( PrevSelectedMap ~= MapName )
	{
		MapWindow.ListVoteStatus.SelectMap(PrevSelectedMap);
	}
}

function Paint(Canvas C, float X, float Y)
{
	local Texture T;

	T = GetLookAndFeelTexture();
	DrawUpBevel( C, 0, LookAndFeel.TabUnselectedM.H, WinWidth, WinHeight-LookAndFeel.TabUnselectedM.H, T);
}

function DebugLog(string Msg)
{
	if (bDebugMode)
	    Log("**** TabWindow " $ Msg);
}

function Close(optional bool bByParent)
{
	Super.Close(bByParent);
}

defaultproperties
{
}
