//============================================================================
//                             MapVoteTopGames
//============================================================================
//
class MapVoteTopGames extends Info Config(MapVoteXM);

var MapVoteX   myMut;
var MapVoteGRI MVGRI;

var int  iDate;
var bool Initialized;

Const NumGames = 30;

struct GameConf
{
	var int Date;
	var int GameCount;
	var string GameName;
};

var() Config GameConf TopGames[31];

function PostBeginPlay()
{
	if (!Initialized)
	{
		Initialized = true;
		GetDate();
		SaveConfig();
	}
}

function LoadStuff()
{
    local int i;

    if (MVGRI == None)
    {
        foreach AllActors( class'MapVoteGRI', MVGRI )
        break;
    }

    for (i=0; i<NumGames; i++)
    {
         MVGRI.TopGameCount[i+1] = TopGames[i].GameCount;
         MVGRI.TopGameNames[i+1] = TopGames[i].GameName;
    }
}

function DeleteGames()
{
    local int i;

    for (i=NumGames/2; i<NumGames; i++)
    {
        TopGames[i].Date = 0;
        TopGames[i].GameCount = 0;
        TopGames[i].GameName = "";
    }
    SaveConfig();
    LoadStuff();

}

function SetGameStuff(string sGame)
{
    local bool bFound;
    local int i;

    bFound = false;

    for (i=0; i<NumGames; i++)
    {
        if (TopGames[i].GameName == "" || TopGames[i].GameCount == 0)
            break;
        if (Caps(TopGames[i].GameName) == Caps(sGame))
        {
            bFound = true;
            if (TopGames[i].GameCount < 999)
                TopGames[i].GameCount++;
            break;
        }
    }

    if (!bFound)
    {
        GetDate();
        if (i < NumGames-1)
        {
            TopGames[i].Date = iDate;
            TopGames[i].GameName = sGame;
            TopGames[i].GameCount = 1;
        }
        else
        {
            bFound = false;
            for (i=0; i<NumGames; i++)
            {
                if (TopGames[i].GameCount == 1)
                {
                    if (TopGames[i].Date < iDate)
                    {
                        TopGames[i].Date = iDate;
                        TopGames[i].GameName = sGame;
                        TopGames[i].GameCount = 1;
                        bFound = true;
                        break;
                    }
                }
            }
            if (!bFound)
            {
                TopGames[NumGames-1].Date = iDate;
                TopGames[NumGames-1].GameName = sGame;
                TopGames[NumGames-1].GameCount = 1;
            }
        }
    }
    SortGameStuff();
}

function SortGameStuff()
{
    local string sTemp;
    local int a, b, x;

    for(a=0; a<=NumGames-1; a++)
    {
       for(b=a+1; b<=NumGames; b++)
       {
          if (TopGames[a].GameCount < TopGames[b].GameCount)
          {
              x     = TopGames[a].GameCount;
              sTemp = TopGames[a].GameName;
              TopGames[a].GameCount = TopGames[b].GameCount;
              TopGames[a].GameName  = TopGames[b].GameName;
              TopGames[b].GameCount = x;
              TopGames[b].GameName  = sTemp;
          }
       }
    }
    SaveConfig();
}

function GetDate()                     //2021-2000 x 365 + monthx31 + day
{
    local int Yr, Mn, Dy;

    Yr = Level.Year - 2000;
    Mn = Level.Month;
    Dy = Level.Day;

    iDate = (Yr*365) + (mn*31) + Dy;
}

defaultproperties
{
}
