//============================================================================
//                             MapVoteTopMaps
//============================================================================
//
class MapVoteTopMaps extends Info Config(MapVoteXM);

var MapVoteX   myMut;
var MapVoteGRI MVGRI;

var int  iDate;
var bool Initialized;

Const NumMaps  = 100;

struct MapStuff
{
	var int Date;
	var int MapCount;
	var string MapName;
};

var() Config MapStuff TopMaps[101];

function PostBeginPlay()
{
	if (!Initialized)
	{
		Initialized = true;
		GetDate();
		SaveConfig();
	}
}

function LoadStuff()
{
    local int i;

    if (MVGRI == None)
    {
        foreach AllActors( class'MapVoteGRI', MVGRI )
        break;
    }

    for (i=0; i<NumMaps; i++)
    {
         MVGRI.TopMapCount[i+1] = string(TopMaps[i].MapCount);
         MVGRI.TopMapNames[i+1] = TopMaps[i].MapName;
    }
}

function DeleteMaps()
{
    local int i;

    for (i=NumMaps/2; i<NumMaps; i++)
    {
        TopMaps[i].Date = 0;
        TopMaps[i].MapCount = 0;
        TopMaps[i].MapName = "";
    }
    SaveConfig();
    LoadStuff();

}

function SetMapStuff(string sMap)
{
    local bool bFound;
    local int i;

    bFound = false;

    for (i=0; i<NumMaps; i++)
    {
        if (TopMaps[i].MapName == "" || TopMaps[i].MapCount == 0)
            break;
        if (Caps(TopMaps[i].MapName) == Caps(sMap))
        {
            bFound = true;
            if (TopMaps[i].MapCount < 999)
                TopMaps[i].MapCount++;
            break;
        }
    }

    if (!bFound)
    {
        GetDate();
        if (i < NumMaps-1)
        {
            TopMaps[i].Date = iDate;
            TopMaps[i].MapName = sMap;
            TopMaps[i].MapCount = 1;
        }
        else
        {
            bFound = false;
            for (i=0; i<NumMaps; i++)
            {
                if (TopMaps[i].MapCount == 1)
                {
                    if (TopMaps[i].Date < iDate)
                    {
                        TopMaps[i].Date = iDate;
                        TopMaps[i].MapName = sMap;
                        TopMaps[i].MapCount = 1;
                        bFound = true;
                        break;
                    }
                }
            }
            if (!bFound)
            {
                TopMaps[NumMaps-1].Date = iDate;
                TopMaps[NumMaps-1].MapName = sMap;
                TopMaps[NumMaps-1].MapCount = 1;
            }
        }
    }
    SortMapStuff();
}

function SortMapStuff()
{
    local string sTemp;
    local int a, b, x;

    for(a=0; a<=NumMaps-1; a++)
    {
       for(b=a+1; b<=NumMaps; b++)
       {
          if (TopMaps[a].MapCount < TopMaps[b].MapCount)
          {
              x     = TopMaps[a].MapCount;
              sTemp = TopMaps[a].MapName;
              TopMaps[a].MapCount = TopMaps[b].MapCount;
              TopMaps[a].MapName  = TopMaps[b].MapName;
              TopMaps[b].MapCount = x;
              TopMaps[b].MapName  = sTemp;
          }
       }
    }
    SaveConfig();
}

function GetDate()                     //2021-2000 x 365 + monthx31 + day
{
    local int Yr, Mn, Dy;

    Yr = Level.Year - 2000;
    Mn = Level.Month;
    Dy = Level.Day;

    iDate = (Yr*365) + (mn*31) + Dy;
}

defaultproperties
{
}
