//================================================================================
// MapVoteWindowAdmin.
//================================================================================
//
class MapVoteWindowAdmin extends UWindowPageWindow;

var MapVoteGRI MVGRI;

var color WhiteColor, GrayColor;

var UWindowCheckbox CheckAutoOpen;
var UWindowCheckbox CheckMidGame;
var UWindowCheckbox CheckDebugMode;
var UWindowCheckbox CheckKillBots;
var UWindowCheckbox CheckAddBot;

var UWindowCheckbox CheckMajority;
var UWindowCheckbox CheckIdler;
var UWindowCheckbox CheckWelcome;
var UWindowCheckbox CheckSortGame;
var UWindowCheckbox CheckEmptySwt;
var UWindowCheckbox CheckEmptyRandom;
var UWindowCheckbox GameEndVote;

var UWindowHSliderControl SlideTick;
var UMenuLabelControl     LabelTick;
var UWindowHSliderControl SlideTime;
var UMenuLabelControl     LabelTime;
var UWindowHSliderControl SlideDely;
var UMenuLabelControl     LabelDely;
var UWindowHSliderControl SlideVote;
var UMenuLabelControl     LabelVote;
var UWindowHSliderControl SlidePopup;
var UMenuLabelControl     LabelPopup;
var UWindowHSliderControl SlideRepeat;
var UMenuLabelControl     LabelRepeat;

var UMenuLabelControl     LabelHelp;

var UWindowSmallButton AddBotButton;
var UWindowSmallButton RemBotButton;
var UWindowSmallButton EndedButton;
var UWindowSmallButton ServerButton;
var UWindowSmallButton ResetButton;

var UWindowSmallButton SubmitButton;
var UWindowSmallButton CloseButton;

var bool   bStuffSet;
var string sCode;
var bool   bInitialized;

var bool bHelp;
var int  HelpCount;

var int  TickTock;

function Created ()
{
	Super.Created();

    bInitialized = false;
    bStuffSet = false;

    if (MVGRI == none)
    {
        foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
        break;
    }

    CheckAutoOpen = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 30, 160, 1));
    CheckAutoOpen.TextColor = WhiteColor;
    CheckAutoOpen.SetText("Auto Open Vote Menu");

    CheckMidGame = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 50, 160, 1));
    CheckMidGame.TextColor = WhiteColor;
    CheckMidGame.SetText("Enable Mid Game Voting");

    CheckMajority = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 70, 160, 1));
    CheckMajority.TextColor = WhiteColor;
    CheckMajority.SetText("Enable Majority Playervote");

    CheckIdler = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 90, 160, 1));
    CheckIdler.TextColor = WhiteColor;
    CheckIdler.SetText("Enable Idler to Spectator");

    CheckKillBots = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 110, 160, 1));
    CheckKillBots.TextColor = WhiteColor;
    CheckKillBots.SetText("Enable 2 player !KillBots");

    CheckAddBot = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 130, 160, 1));
    CheckAddBot.TextColor = WhiteColor;
    CheckAddBot.SetText("Enable 2 player !AddBot");

    CheckWelcome = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 30, 160, 1));
    CheckWelcome.TextColor = WhiteColor;
    CheckWelcome.SetText("Enable Welcome Window");

    CheckDebugMode = UWindowCheckbox(CreateControl(class'UWindowCheckbox',210, 50, 160, 1));
    CheckDebugMode.TextColor = WhiteColor;
    CheckDebugMode.SetText("Enable Log Debug Mode");

    CheckSortGame = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 70, 160, 1));
    CheckSortGame.TextColor = WhiteColor;
    CheckSortGame.SetText("Sort Custom Game List");

    GameEndVote = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 90, 160, 1));
    GameEndVote.TextColor = WhiteColor;
    GameEndVote.SetText("Disable GameEnd Voting");

    CheckEmptySwt = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 110, 160, 1));
    CheckEmptySwt.TextColor = WhiteColor;
    CheckEmptySwt.SetText("Enable Empty Server Switch");

    CheckEmptyRandom = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 130, 160, 1));
    CheckEmptyRandom.TextColor = WhiteColor;
    CheckEmptyRandom.SetText("Enable Empty Random Switch");

    LabelHelp = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 80, 145, 240, 16));
    LabelHelp.SetText("");
    LabelHelp.TextColor = GrayColor;

    SlideTick = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 152, 220, 30));
    SlideTick.bAcceptsFocus = False;
    SlideTick.MinValue = 30;
    SlideTick.MaxValue = 120;
    SlideTick.Step = 5;
    SlideTick.SetText("Set Server TickRate");
    SlideTick.TextColor = WhiteColor;

    LabelTick = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 152, 60, 16));
    LabelTick.SetText("");
    LabelTick.TextColor = WhiteColor;

    SlideTime = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 168, 220, 30));
    SlideTime.bAcceptsFocus = False;
    SlideTime.MinValue = 5;
    SlideTime.MaxValue = 60;
    SlideTime.Step = 5;
    SlideTime.SetText("Empty Server Switch");
    SlideTime.SetValue(15);
    SlideTime.TextColor = WhiteColor;

    LabelTime = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 168, 60, 16));
    LabelTime.SetText("");
    LabelTime.TextColor = WhiteColor;

    SlideDely = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 184, 220, 30));
    SlideDely.bAcceptsFocus = False;
    SlideDely.MinValue = 1;
    SlideDely.MaxValue = 120; //30;
    SlideDely.Step = 1;
    SlideDely.SetText("Game Start Vote Delay");
    SlideDely.SetValue(15);
    SlideDely.TextColor = WhiteColor;

    LabelDely = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 184, 60, 16));
    LabelDely.SetText("");
    LabelDely.TextColor = WhiteColor;

    SlideVote = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 200, 220, 30));
    SlideVote.bAcceptsFocus = False;
    SlideVote.MinValue = 10;
    SlideVote.MaxValue = 300; //180
    SlideVote.Step = 10;
    SlideVote.SetText("Voting Time Limit");
    SlideVote.SetValue(50);
    SlideVote.TextColor = WhiteColor;

    LabelVote = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 200, 60, 16));
    LabelVote.SetText("");
    LabelVote.TextColor = WhiteColor;

    SlidePopup = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 216, 220, 30));
    SlidePopup.bAcceptsFocus = False;
    SlidePopup.MinValue = 2;
    SlidePopup.MaxValue = 30;
    SlidePopup.Step = 2;
    SlidePopup.SetText("Menu Popup Delay");
    SlidePopup.SetValue(10);
    SlidePopup.TextColor = WhiteColor;

    LabelPopup = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 216, 60, 16));
    LabelPopup.SetText("");
    LabelPopup.TextColor = WhiteColor;

    SlideRepeat = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 232, 220, 30));
    SlideRepeat.bAcceptsFocus = False;
    SlideRepeat.MinValue = 0;
    SlideRepeat.MaxValue = 20;
    SlideRepeat.Step = 1;
    SlideRepeat.SetText("Map Repeat Limit");
    SlideRepeat.SetValue(5);
    SlideRepeat.TextColor = WhiteColor;

    LabelRepeat = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 232, 60, 16));
    LabelRepeat.SetText("");
    LabelRepeat.TextColor = WhiteColor;

    SubmitButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',140, 255, 115, 20)); //140, 275, 115, 20
	SubmitButton.DownSound=Sound'GlassTink1';
	SubmitButton.Text="Submit";
	SubmitButton.bDisabled=False;

    ServerButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',15, 275, 110, 20));
	ServerButton.DownSound=Sound'GlassTink1';
	ServerButton.Text="Restart Server";
	ServerButton.bDisabled=False;

    ResetButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',140, 275, 115, 20));
	ResetButton.DownSound=Sound'GlassTink1';
	ResetButton.Text="Reset Server";
	ResetButton.bDisabled=MVGRI.bGameEnded;

    RemBotButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',270, 275, 110, 20));
	RemBotButton.DownSound=Sound'GlassTink1';
	RemBotButton.Text="Kill a Bot";
	RemBotButton.bDisabled=False;

    EndedButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',15, 295, 110, 20));
	EndedButton.DownSound=Sound'GlassTink1';
	EndedButton.Text="End Game";
	EndedButton.bDisabled=False;

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',140, 295, 115, 20));
	CloseButton.DownSound=Sound'GlassTink1';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;

    AddBotButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',270, 295, 110, 20));
	AddBotButton.DownSound=Sound'GlassTink1';
	AddBotButton.Text="Add a Bot";
	AddBotButton.bDisabled=False;

    SetAcceptsFocus();
    bInitialized = true;
    TickChanged();
    TimeChanged();
    DelyChanged();
    VoteChanged();
    PopupChanged();
    RepeatChanged();
}

function Notify (UWindowDialogControl C, byte E)
{
    Super.Notify(C,E);

    Switch(E)
    {
	  case DE_Click:
	  switch(C)
      {
      case AddBotButton:
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"AddBot");
           break;
      case ResetButton:
           if (!MVGRI.bGameEnded)
           {
               GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"RestartServer");
               ParentWindow.ParentWindow.Close();
           }
           break;
      case ServerButton:
           ParentWindow.ParentWindow.Close();
           GetPlayerOwner().ConsoleCommand("Admin Exit");
           break;
      case RemBotButton:
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"RemBot");
           break;
      case EndedButton:
           ParentWindow.ParentWindow.Close();
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"ForceGameEnd");
           break;
      case SubmitButton:
           SubmitStuff();
           ParentWindow.ParentWindow.Close();
           break;
      case CloseButton:
           ParentWindow.ParentWindow.bLeaveOnScreen = True;
           ParentWindow.ParentWindow.Close();
           break;
      }
      break;
      case DE_Change:
      switch(C)
      {
      case CheckDebugMode:
      case CheckSortGame:
      case CheckEmptySwt:
         ShowHelp();
         break;
      case CheckEmptyRandom:
         ShowHelp();
         break;
      case SlideTick:
         TickChanged();
         break;
      case SlideTime:
         TimeChanged();
         break;
      case SlideDely:
         DelyChanged();
         break;
      case SlideVote:
         VoteChanged();
         break;
      case SlidePopup:
         PopupChanged();
         break;
      case SlideRepeat:
         RepeatChanged();
         break;
      }
      break;
    }
}

function ShowHelp()
{
    LabelHelp.SetText("This option will only take place on the next level!");
    HelpCount = 0;
    bHelp = True;
}

function ReceiveStuff(string Stuff)
{
    local int i;
    local string sTemp;

    if (!bStuffSet && Len(Stuff) > 20)
    {
       bStuffSet = True;

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckAutoOpen.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckMidGame.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckDebugMode.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckKillBots.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckAddBot.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckMajority.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckIdler.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckWelcome.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckSortGame.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckEmptySwt.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckEmptyRandom.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       GameEndVote.bChecked = bool(i);

       //---------------- sliders -------------------

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideTime.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideDely.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideVote.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlidePopup.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideRepeat.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideTick.SetValue(i);
    }
}

function SubmitStuff()
{
    local string sTemp, s0, s1;

    s0 = "0,";
    s1 = "1,";

    if (CheckAutoOpen.bChecked)       // wouldn't work any other way ?
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckMidGame.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckDebugMode.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckKillBots.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckAddBot.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckMajority.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckIdler.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckWelcome.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckSortGame.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckEmptySwt.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckEmptyRandom.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (GameEndVote.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    //---------------- sliders -------------------

    sTemp = sTemp$string(int(SlideTime.Value))$","$string(int(SlideDely.Value))$","$string(int(SlideVote.Value))$",";
    sTemp = sTemp$string(int(SlidePopup.Value))$","$string(int(SlideRepeat.Value))$","$string(int(SlideTick.Value))$",";

    GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"Admin "$sTemp);
}

function TickChanged()
{
    if (bInitialized)
       LabelTick.SetText(string(int(SlideTick.Value)) $ " Ticks");
}

function TimeChanged()
{
    if (bInitialized)
       LabelTime.SetText(string(int(SlideTime.Value)) $ " Minutes");
}

function DelyChanged()
{
    if (bInitialized)
       LabelDely.SetText(string(int(SlideDely.Value)) $ " Seconds");
}

function VoteChanged()
{
    if (bInitialized)
       LabelVote.SetText(string(int(SlideVote.Value)) $ " Seconds");
}

function PopupChanged()
{
    if (bInitialized)
       LabelPopup.SetText(string(int(SlidePopup.Value)) $ " Seconds");
}

function RepeatChanged()
{
    if (bInitialized)
    {
       if (SlideRepeat.Value < 1)
          LabelRepeat.SetText("Disabled");
       else
          LabelRepeat.SetText(string(int(SlideRepeat.Value)) $ " Levels");
    }
}

function Tick (float DeltaTime)
{
    Super.Tick(DeltaTime);

    if (bHelp && HelpCount++ == 200)
    {
        LabelHelp.SetText("");
        bHelp = false;
    }
}

function Paint (Canvas C, float MouseX, float MouseY)
{
    local Texture MVX;

	Super.Paint(C,MouseX,MouseY);

    MVX = Texture'mvx1';

    C.DrawColor = class'MapVotePosition'.default.BackGroundColor;
    DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'Grad1');

    C.DrawColor = WhiteColor;
    C.Style = GetPlayerOwner().ERenderStyle.STY_Translucent;
    C.SetPos( C.ClipX / 2 - MVX.Usize / 2 - 4, 7);
    C.DrawIcon( MVX, 1.0 );
    C.Style = GetPlayerOwner().ERenderStyle.STY_Normal;
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}
//
defaultproperties
{
    GrayColor=(R=128,G=128,B=128)
    WhiteColor=(R=255,G=255,B=255)
}
