//================================================================================
// MapVoteWindowFrame - Client
//================================================================================
//
class MapVoteWindowFrame extends UWindowFramedWindow;

var MapVoteWRI MVWRI;

var int Xpos;
var int Ypos;
var int Tock;

function created()
{
	super.created();

	bLeaveOnScreen = true;
	bMoving = true;
	bStatusBar = False;
	bSizable = False;
    Tock = 0;

    if (MVWRI == none)
    {
        foreach GetPlayerOwner().AllActors( class'MapVoteWRI', MVWRI )
        break;
    }

    Xpos = class'MapVotePosition'.default.VotePositionX;
    Ypos = class'MapVotePosition'.default.VotePositionY;

	SetSizePos();
}

function ResolutionChanged(float W, float H)
{
	SetSizePos();
	Super.ResolutionChanged(W, H);
}

function SetSizePos()
{
	SetSize(400, 355);

    WinLeft = ((Root.WinWidth  - WinWidth)  / 100) * (Xpos);
    WinTop  = ((Root.WinHeight - WinHeight) / 100) * (Ypos);
}

function Tick(float DeltaTime)
{
    local int x, y;

    x = self.WinLeft / ((Root.WinWidth - WinWidth) / 100);
    y = self.WinTop / ((Root.WinHeight - WinHeight) / 100);

    if (Tock++ > 25)  // approx .5 sec
    {
        Tock = 0;
        if (Xpos != x || Ypos != y)
        {
            Xpos = x;
            Ypos = y;

            if (Xpos > 100)
                Xpos = 100;
            if (Ypos > 100)
                Ypos = 100;
            if (Xpos < 0)
                Xpos = 0;
            if (Ypos < 0)
                Ypos = 0;

            class'MapVotePosition'.default.VotePositionX = Xpos;
            class'MapVotePosition'.default.VotePositionY = Ypos;
            class'MapVotePosition'.static.StaticSaveConfig();
        }
        if (MVWRI != none)
            WindowTitle = MVWRI.sTitle;
        else
            WindowTitle = "MapVoteX";
    }

    Super.Tick(DeltaTime);
}

function Resized()
{
	// Supress ScriptWarning..
	if (ClientArea == None)
	    return;

	Super.Resized();
}

function Close(optional bool bByParent)
{
    Root.Console.CloseUWindow();
	Super.Close(bByParent);
}

defaultproperties
{
    ClientClass=class'MapVoteTabWindow'
}
