//================================================================================
// MapVoteWindowMess
//================================================================================
//
class MapVoteWindowMess extends UWindowPageWindow Config(MapVoteMessages);

var UMenuLabelControl  lblHeading;
var MapVoteTextArea    TheTextArea;
var UWindowHScrollBar  HorizSB;

var UWindowSmallButton SaveButton;
var UWindowSmallButton DelButton;
var UWindowSmallButton CloseButton;

var color clGreen;
var color clSilver;
var float ClientHeight, ClientWidth;

var() config string Messages[51];

var string sCode;

function Created ()
{
	Super.Created();

	lblHeading=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',0.00,2.00,370,20.00));
	lblHeading.SetText(" No  Date    Time    Nickname / Message");
	lblHeading.Align=TA_Left;
	lblHeading.SetTextColor(clGreen);

	TheTextArea = MapVoteTextArea(CreateControl(Class'MapVoteTextArea',1, 14, 390, 260));
	TheTextArea.bAutoScrollbar = False;
	TheTextArea.SetTextColor(clSilver);
	TheTextArea.WrapWidth = 2000;
	TheTextArea.Clear();

	HorizSB = UWindowHScrollbar(CreateWindow(class'UWindowHScrollbar', 1, 277, 380, 12));
	HorizSB.bAlwaysOnTop = True;

	ClientHeight = 277;
	ClientWidth = 450;

    SaveButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',15, 295,  110, 20));
	SaveButton.DownSound=Sound'GlassTink1';
	SaveButton.Text="Save All";
	SaveButton.bDisabled=False;

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',140, 295,  115, 20));
	CloseButton.DownSound=Sound'GlassTink1';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;

    DelButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',270, 295,  110, 20));
	DelButton.DownSound=Sound'GlassTink1';
	DelButton.Text="Delete All";
	DelButton.bDisabled=False;

    SetAcceptsFocus();
}

function Notify (UWindowDialogControl C, byte E)
{
    Super.Notify(C,E);

    Switch(E)
    {
	  case DE_Click:
	  switch(C)
      {
		case SaveButton:
             SaveConfig();
 		     break;
		case DelButton:
             ParentWindow.ParentWindow.Close();
             GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"DeleteAdminMessages");
 		     break;
 		case CloseButton:
 		     ParentWindow.ParentWindow.Close();
 		     break;
		default:
	  }
    }
}

function Tick( float delta )
{

    if (HorizSB.Pos != TheTextArea.MyPos) // activates the horz scrollbar
    {
        TheTextArea.MyPos = HorizSB.Pos;
    }

    Super.Tick(delta);
}

function BeforePaint( Canvas C, float X, float Y )
{
	Super.BeforePaint(C, X, Y);

	HorizSB.ShowWindow();
	HorizSB.WinLeft = 1;
	HorizSB.WinTop = ClientHeight;
	HorizSB.WinHeight = LookAndFeel.Size_ScrollbarWidth;
	HorizSB.WinWidth = WinWidth - LookAndFeel.Size_ScrollbarWidth + 10;
	HorizSB.SetRange(0, ClientWidth*1.5, HorizSB.WinWidth, 10);
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	Super.Paint(C,MouseX,MouseY);

    DrawStretchedTexture(C, 0, 0, WinWidth, WinHeight, Texture'BlackTexture');
    C.Style = GetPlayerOwner().ERenderStyle.STY_Normal;
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}

defaultproperties
{
    clSilver=(R=200,G=200,B=200)
    clGreen=(R=0,G=255,B=32)
}
