//================================================================================
// MapVoteWindowTops
//================================================================================
//
class MapVoteWindowTops extends UWindowPageWindow Config(MapVoteTops);

var MapVoteGRI MVGRI;

var UMenuLabelControl  lblTopMaps;
var UMenuLabelControl  lblTopGames;
var MapVoteTextArea    TopGameArea;
var MapVoteTextArea    TopMapsArea;

var UWindowHScrollBar  GameHorBar;
var UWindowHScrollBar  MapsHorBar;

var UWindowSmallButton DelGameButton;
var UWindowSmallButton DelMapButton;
var UWindowSmallButton CloseButton;

var color clGreen;
var color clSilver;
var float ClientHeight, ClientWidth;

var string sCode;
var bool   bAdmin;
var int    BarTop;

function Created ()
{
	Super.Created();

    if (GetPlayerOwner().bAdmin)
        bAdmin = GetPlayerOwner().bAdmin;
    else
        bAdmin = GetPlayerOwner().PlayerReplicationInfo.bAdmin;

	lblTopGames=UMenuLabelControl(CreateControl(Class'UMenuLabelControl', 0, 1, 190, 20));
	lblTopGames.SetText(" No  Cnt    Top Games");
	lblTopGames.Align=TA_Left;
	lblTopGames.SetTextColor(clGreen);

	TopGameArea = MapVoteTextArea(CreateControl(Class'MapVoteTextArea', 1, 12, 200, 263));
	TopGameArea.bAutoScrollbar = False;
	TopGameArea.SetTextColor(clSilver);
	TopGameArea.WrapWidth = 2000;
	TopGameArea.Clear();
    TopGameArea.bTopCentric = True;

    BarTop = 278;

	GameHorBar = UWindowHScrollbar(CreateWindow(class'UWindowHScrollbar', 1, BarTop, 200, 12));
	GameHorBar.bAlwaysOnTop = True;

	lblTopMaps=UMenuLabelControl(CreateControl(Class'UMenuLabelControl', 200, 1, 190, 20));
	lblTopMaps.SetText(" No  Cnt    Top Maps");
	lblTopMaps.Align=TA_Left;
	lblTopMaps.SetTextColor(clGreen);

	TopMapsArea = MapVoteTextArea(CreateControl(Class'MapVoteTextArea', 201, 12, 190, 263));
	TopMapsArea.bAutoScrollbar = False;
	TopMapsArea.SetTextColor(clSilver);
	TopMapsArea.WrapWidth = 2000;
	TopMapsArea.Clear();
	TopMapsArea.bTopCentric = True;

	MapsHorBar = UWindowHScrollbar(CreateWindow(class'UWindowHScrollbar', 201, BarTop, 190, 12));
	MapsHorBar.bAlwaysOnTop = True;

    if (bAdmin)
    {
        DelGameButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',15, 295,  110, 20));
		DelGameButton.DownSound=Sound'GlassTink1';
		DelGameButton.Text="Delete ";
		DelGameButton.bDisabled=False;

        DelMapButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',270, 295,  110, 20));
		DelMapButton.DownSound=Sound'GlassTink1';
		DelMapButton.Text="Delete ";
		DelMapButton.bDisabled=False;
    }

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',140, 295,  115, 20));
	CloseButton.DownSound=Sound'GlassTink1';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;

    SetAcceptsFocus();
}

function Notify (UWindowDialogControl C, byte E)
{
    Super.Notify(C,E);

    Switch(E)
    {
	  case DE_Click:
	  switch(C)
      {
		case DelGameButton:
             ParentWindow.ParentWindow.Close();
             GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"DeleteTopGames");
 		     break;
		case DelMapButton:
             ParentWindow.ParentWindow.Close();
             GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"DeleteTopMaps");
 		     break;
 		case CloseButton:
 		     ParentWindow.ParentWindow.Close();
 		     break;
		default:
	  }
    }
}

function Tick( float delta )
{

    if (GameHorBar.Pos != TopGameArea.MyPos) // activates the horz scrollbar
        TopGameArea.MyPos = GameHorBar.Pos;

    if (MapsHorBar.Pos != TopMapsArea.MyPos) // activates the horz scrollbar
        TopMapsArea.MyPos = MapsHorBar.Pos;

    Super.Tick(delta);
}

function LoadGameMaps()
{
    local string sNum, sTemp;
    local int i, j;

    if (MVGRI == none)
    {
        foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
        break;
    }

    if (MVGRI == none)
        return;

    TopGameArea.Clear();

    for (i=1; i<31; i++)
    {
        j = MVGRI.TopGameCount[i];
        if (j < 1)
            break;

        if (i < 10)
            sNum = "0";
        else
            sNum = "";

        if (j < 10)
            sTemp = "   00";
        else
        if (j < 100)
            sTemp = "   0";
        else
            sTemp = "   ";

        sTemp = sNum$i$sTemp$j$"   "$MVGRI.TopGameNames[i];
        TopGameArea.AddText(sTemp);
    }

    TopMapsArea.Clear();

    for (i=1; i<101; i++)
    {
        j = int(MVGRI.TopMapCount[i]);

        if (j < 1)
            break;

        if (i < 10)
            sNum = "0";
        else
            sNum = "";

        if (j < 10)
            sTemp = "   00";
        else
        if (j < 100)
            sTemp = "   0";
        else
            sTemp = "   ";

        sTemp = sNum$i$sTemp$j$"   "$MVGRI.TopMapNames[i];
        TopMapsArea.AddText(sTemp);
    }
}

function BeforePaint( Canvas C, float X, float Y )
{
	Super.BeforePaint(C, X, Y);

	GameHorBar.ShowWindow();
	GameHorBar.WinLeft = 1;
	GameHorBar.WinTop = BarTop;
	GameHorBar.WinHeight = LookAndFeel.Size_ScrollbarWidth;
	GameHorBar.WinWidth = 200;
	GameHorBar.SetRange(0, 200, GameHorBar.WinWidth*0.5, 10);

	MapsHorBar.ShowWindow();
	MapsHorBar.WinLeft = 201;
	MapsHorBar.WinTop = BarTop;
	MapsHorBar.WinHeight = LookAndFeel.Size_ScrollbarWidth;
	MapsHorBar.WinWidth = 190;
	MapsHorBar.SetRange(0, 190, MapsHorBar.WinWidth*0.5, 10);
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	Super.Paint(C,MouseX,MouseY);

    C.DrawColor = class'MapVotePosition'.default.BackGroundColor;
    DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'Grad1');
    C.Style = GetPlayerOwner().ERenderStyle.STY_Normal;
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}

defaultproperties
{
    clSilver=(R=225,G=225,B=225)
    clGreen=(R=0,G=255,B=32)
}
