//================================================================================
// MapVoteWindowVote - Client
//================================================================================
//
class MapVoteWindowVote extends UWindowPageWindow;

var MapVoteGRI MVGRI;

var MapVoteListBox MapListBox;
var MapVoteListBox GameListBox;
var MapVoteEditControl EditMesg;

var UWindowSmallButton ButRandMap;
var UWindowSmallButton ButRandGam;
var UWindowSmallButton ButRestart;
var UWindowSmallButton VoteButton;
var UWindowSmallButton SendButton;
var UWindowSmallButton CloseButton;

var MapVoteStatusListBox ListVoteStatus;
var MapVotePlayerListBox ListVotePlayer;

var UMenuLabelControl lblStatusTitles;
var UMenuLabelControl lblTitle;
var UMenuLabelControl lblMaptxt;
var UMenuLabelControl lblGametxt;
var UMenuLabelControl lblMesg;
var UMenuLabelControl lblFind;
var UMenuLabelControl lblCopy;
var UMenuLabelControl lblDate;

var Texture Screenshot;
var Color SilvColor, TextColor, YellColor, GrayColor;
var int LastMapCount;
var int MapsOnlyCount;
var int PlayerNum;

var string MapTitle;
var string IdealPlayerCount;
var float LastVoteTime;
var float SelectionTime;
var string LogoTexture;
var int MapListwidth;
var int ListHeight;
var int NumMaps, NumGams;
var int GameNum;

var string GameList[201];
var string GameMaps[201];
var string ThisGame;
var string GameMap;
var string sCode;
var string sMapPref;
var string TextEdit;
var string CurrentMap;
var string sTitle;

var bool bMapAlreadySet;
var bool bGameSelect;
var bool bShowPlayers;
var bool bDebugMode;
var bool bFindMap;
var bool bFindGam;
var bool bMapsOnly;
var bool bBusy;
var bool bGrayedOut;
var bool bNoBots;
var bool bAdmin;

function Created ()
{
    local int i;

    for (i=0; i<201; i++)
    {
        GameList[i] = "";
        GameMaps[i] = "";
    }

    bFindMap = false;
    bFindGam = false;
    sTitle = "MapVoteX";

	MapListwidth=180;
	ListHeight=240;

    if (GetPlayerOwner().bAdmin)
        bAdmin = GetPlayerOwner().bAdmin;
    else
        bAdmin = GetPlayerOwner().PlayerReplicationInfo.bAdmin;

	Super.Created();
}

function SetupClientWindow()
{
    local int VoteP;

    VoteP = 273;

    if ( MVGRI == none )
    {
       foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
       break;
    }

    if (bMapsOnly)
    {
        ThisGame = MVGRI.GameName; // mvgamename
        sMapPref = MVGRI.MapPref;  // map prefix
        if (sCode == "")
            sCode = MVGRI.sCode;
    }
    else
    {
        ThisGame = MVGRI.GameStuff2[202]; // mvgamename
        sMapPref = MVGRI.GameStuff2[203]; // map prefix
        GameNum  = int(MVGRI.GameStuff2[204]); // number of games
        CurrentMap = MVGRI.RestartMap;

        if (sCode == "")
            sCode = MVGRI.sCode;
    }

	lblTitle=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',0.00, 10.00, MapListwidth, 20.00));
	lblTitle.SetFont(1);
	lblTitle.SetText(ThisGame);
	lblTitle.Align=TA_Center;
	lblTitle.SetTextColor(YellColor);

	MapListBox=MapVoteListBox(CreateControl(Class'MapVoteListBox',10.00,26.00,MapListwidth,ListHeight));
	MapListBox.Items.Clear();

    lblGametxt=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',20.00 + MapListwidth,10,MapListwidth,10.00));
	lblGametxt.SetFont(1);
	lblGametxt.SetText("Custom Game List");
	if (bMapsOnly)
	    lblGametxt.SetText("");
	lblGametxt.Align=TA_Center;
	lblGametxt.SetTextColor(YellColor);

    if (bMapsOnly)
    {
	    lblCopy=UMenuLabelControl(CreateControl(Class'UMenuLabelControl', 20 + MapListwidth, 108.00, MapListwidth, 10.00));
	    lblTitle.SetFont(0);
	    lblCopy.SetTextColor(SilvColor);
	    lblCopy.SetText(" ProAsm & noOne");
	    lblCopy.Align=TA_Center;

	    lblDate=UMenuLabelControl(CreateControl(Class'UMenuLabelControl', 20 + MapListwidth, 118.00, MapListwidth, 10.00));
	    lblTitle.SetFont(0);
	    lblDate.SetTextColor(SilvColor);
	    lblDate.SetText("2011 - 2022");
	    lblDate.Align=TA_Center;
    }
    else
    {
        GameListBox=MapVoteListBox(CreateControl(Class'MapVoteListBox', 20 + MapListwidth, 26.00, MapListwidth+5, 110));
	    GameListBox.Items.Clear();
  	    GameListBox.ThisGame = ThisGame;
	    GameListBox.GameNum  = GameNum;
    }

	lblStatusTitles=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',25.00 + MapListwidth,140,MapListwidth+5,20.00));
	lblStatusTitles.SetText("Pos   Voted Item                     Votes");
	lblStatusTitles.SetFont(0);
	lblStatusTitles.SetTextColor(TextColor);

	ListVoteStatus=MapVoteStatusListBox(CreateControl(Class'MapVoteStatusListBox',20.00 + MapListwidth,155,MapListwidth+5, 110));
	ListVoteStatus.bAcceptsFocus=False;
	ListVoteStatus.Items.Clear();

	ListVotePlayer=MapVotePlayerListBox(CreateControl(Class'MapVotePlayerListBox',20.00 + MapListwidth,155,MapListwidth+5, 110));
	ListVotePlayer.bAcceptsFocus=False;
	ListVotePlayer.Items.Clear();
    ListVotePlayer.WinHeight=0;

	lblMaptxt=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',20.00 + MapListwidth, 250, MapListwidth,10.00));
    lblMaptxt.SetTextColor(SilvColor);
	lblMaptxt.SetFont(0);
	lblMaptxt.Align=TA_Center;

	ButRandMap=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 10, VoteP, 80, 21));
	ButRandMap.DownSound=Sound'GlassTink1';
    ButRandMap.Text="Random Map";
    if (bMapsOnly || NumMaps < 4)
        ButRandMap.bDisabled = True;
    else
	    ButRandMap.bDisabled = False;

	ButRandGam=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 300, VoteP, 85, 21));
	ButRandGam.DownSound=Sound'GlassTink1';
	if (bNoBots)
	{
        ButRandGam.Text="Random Game";
        if (bMapsOnly || NumGams < 4)
            ButRandGam.bDisabled=true;
    }
    else
    {
        ButRandGam.Text="Remove Bots";
        if (bMapsOnly)
            ButRandGam.bDisabled=true;
    }

    if (!bMapsOnly && CurrentMap != "")
    {
		ButRestart=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 95, VoteP, 80, 21));
		ButRestart.DownSound=Sound'GlassTink1';
		ButRestart.Text="Restart Map";
		ButRestart.bDisabled=False;

		VoteButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 180, VoteP, 115, 21));
		VoteButton.DownSound=Sound'GlassTink1';
		VoteButton.Text="Vote";
		VoteButton.bDisabled=False;

    }
    else
    {
		VoteButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 95, VoteP, 200, 21));
		VoteButton.DownSound=Sound'GlassTink1';
		VoteButton.Text="Vote";
		VoteButton.bDisabled=False;
    }

	lblMesg=UMenuLabelControl(CreateControl(Class'UMenuLabelControl', 10, 295, 30, 16));
	lblMesg.SetText("Mesg:");
	lblMesg.SetFont(0);
	lblMesg.SetTextColor(TextColor);

	EditMesg=MapVoteEditControl(CreateControl(Class'MapVoteEditControl', 40, 295, 200, 16));
	EditMesg.SetNumericOnly(False);
	EditMesg.SetHistory(True);
	EditMesg.SetMaxLength(80);
	EditMesg.SetValue("");
	EditMesg.Align=TA_Left;
	EditMesg.MVVote = self;

	lblFind=UMenuLabelControl(CreateControl(Class'UMenuLabelControl', 60, 297, 175, 12));
	lblFind.SetText("Search =  ?mapname  /gamename");
	lblFind.SetTextColor(GrayColor);

	SendButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 245, 295, 50, 20));
	SendButton.DownSound=Sound'GlassTink1';
	SendButton.Text="Send";
	SendButton.bDisabled=False;

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 300, 295, 85, 20)); // horzpos,vertpos,width,height
	CloseButton.DownSound=Sound'GlassTink1';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;
}

function DeSelectAllOtherMapListBoxItems(MapVoteListBox SelListBox, int iNum)
{
	if ( iNum != 1 )
	{
		if ( MapListBox.SelectedItem != None )
		{
			MapListBox.SelectedItem.bSelected = False;
		}
		MapListBox.SelectedItem = None;
	}

	if ( iNum != 2 )
	{
		if ( GameListBox.SelectedItem != None )
		{
			GameListBox.SelectedItem.bSelected = False;
		}
		GameListBox.SelectedItem = None;
	}

	if ( iNum == 1 || iNum == 2 )
	{
		SelListBox.MakeSelectedVisible();
	}
}

function UWindowListBoxItem GetSelectedItem ()
{
	if ( MapListBox.SelectedItem != None )
	{
		return MapListBox.SelectedItem;
	}

	if ( GameListBox.SelectedItem != None )
	{
		return GameListBox.SelectedItem;
	}
}

function Notify (UWindowDialogControl C, byte E)
{
    local string sTemp;
	local int ListNum;

     if (GetPlayerOwner().bAdmin)
         bAdmin = GetPlayerOwner().bAdmin;
     else
         bAdmin = GetPlayerOwner().PlayerReplicationInfo.bAdmin;

	Super.Notify(C, E);

	switch (E)
	{
		case 1:
		switch (C)
		{
			default:
		}
		break;
		case 11:
		switch (C)
		{
			case MapListBox:
				if (!MVGRI.bDoubleClickVoting)
				    return; //break;
				if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
				{
					if ( (Left(MapVoteUMenuList(getSelectedItem()).MapName,4) != "[XX]") || bAdmin )
					{
						GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"MAP "$ MapVoteUMenuList(MapListBox.SelectedItem).MapName);
						LastVoteTime=GetPlayerOwner().Level.TimeSeconds;
					}
				}
				SelectionTime=GetPlayerOwner().Level.TimeSeconds;
				DeSelectAllOtherMapListBoxItems(MapListBox, 1);
				break;

			case GameListBox:
				if (!MVGRI.bDoubleClickVoting)
                    return; //break;
				if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
				{
					if ( (Left(MapVoteUMenuList(getSelectedItem()).MapName,4) != "[XX]") || bAdmin )
					{
						sTemp = MapVoteUMenuList(GameListBox.SelectedItem).MapName;
						GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"GAME "$sTemp);
						LastVoteTime=GetPlayerOwner().Level.TimeSeconds;
						lblGametxt.SetText(Mid(sTemp, 4));
					}
				}
				SelectionTime=GetPlayerOwner().Level.TimeSeconds;
				DeSelectAllOtherMapListBoxItems(GameListBox, 1);
				break;

			case ListVoteStatus:
				sTemp = MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName;
				if (sTemp ~= "Random Map")
				{
				    sTemp = "[RR]Random Map";
			        ListNum = 0;
			    }
			    else
				if (sTemp ~= "Random Game")
				{
				    sTemp = "[RG]Random Game";
			        ListNum = 3;
			    }
			    else
			    {
			        ListNum = GetListNum(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
			    }

			    DeSelectAllOtherMapListBoxItems(MapListBox, 0);
				if ( ListNum == 1 )
				{
					MapListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
				}
				else
				if ( ListNum == 2 )
				{
					GameListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
				}

				if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
				{
				    if ( ListNum < 2 )
					   GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"MAP "$sTemp);
					else
					{
					   sTemp = MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName;
					   if (Left(sTemp, 4) != "[GG]" && Left(sTemp, 4) != "[RG]")
					      sTemp = "[GG]"$sTemp;
					   GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"GAME "$sTemp);
					}
					LastVoteTime = GetPlayerOwner().Level.TimeSeconds;
				}
				SelectionTime = GetPlayerOwner().Level.TimeSeconds;
				break;
				default:
		}
		break;
		case 2:
		switch (C)
		{
			case SendButton:
				if ( EditMesg.GetValue() != "" )
				{
					GetPlayerOwner().ConsoleCommand("SAY " $ EditMesg.GetValue());
					EditMesg.SetValue("");
					lblFind.SetText("Search =  ?mapname  /gamename");
				}
				break;
			case ButRestart:
				ButRestartPressed();
				break;
			case VoteButton:
			    VoteButtonPressed();
				break;
			case ButRandMap:
			    ButRandMapPressed();
				break;
			case ButRandGam:
				ButRandGamPressed();
				break;
			case CloseButton:
				ParentWindow.ParentWindow.Close();
				break;
			case MapListBox:
			    if ( Left(MapVoteUMenuList(getSelectedItem()).MapName,4) == "[XX]")
			         VoteButton.bDisabled=True;
			    else
			         VoteButton.bDisabled=False;
				bGameSelect = false;
				MapListBox.VScrol = 19;
 		        MapListBox.sMapPref = sMapPref;
				SelectionTime = GetPlayerOwner().Level.TimeSeconds;
				DeSelectAllOtherMapListBoxItems(MapListBox, 1);
				break;
			case GameListBox:
				sTemp = MapVoteUMenuList(GameListBox.SelectedItem).MapName;
				if (sTemp != "")
				    lblGametxt.SetText(Mid(sTemp, 4));
				bGameSelect = True;
				GameListBox.VScrol = 7;
				GameListBox.sMapPref = "";
				SelectionTime = GetPlayerOwner().Level.TimeSeconds;
				DeSelectAllOtherMapListBoxItems(GameListBox, 2);
				FindGameMap(MapVoteUMenuList(getSelectedItem()).MapName);
				break;
			case ListVoteStatus:
				ListNum = GetListNum(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
				DeSelectAllOtherMapListBoxItems(MapListBox, 0);
				if ( ListNum == 1 )
				{
					MapListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
				}
				if ( ListNum == 2 )
				{
					GameListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
				}
				SelectionTime = GetPlayerOwner().Level.TimeSeconds;
			break;
			default:
		}
		break;
		case 7:
			if ( EditMesg.GetValue() != "" )
			{
			    if (bFindMap || bFindGam)
			    {
			        VoteButtonPressed();
			    }
			    else
			    {
 				    GetPlayerOwner().ConsoleCommand("SAY " $ EditMesg.GetValue());
				    EditMesg.SetValue("");
  				    EditMesg.FocusOtherWindow(SendButton);
  				    lblFind.SetText("Search =  ?mapname  /gamename");
  				}
			}
		break;
		default:
	}
}

function ButRestartPressed()
{
    local string sTemp;

    if (bMapsOnly)
        return;

    sTemp = MVGRI.RestartMap;
	if (sTemp != "")
	{
       GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"MAP "$sTemp);
       LastVoteTime = GetPlayerOwner().Level.TimeSeconds;
       ButRestart.bDisabled = True;
    }
}

function VoteButtonPressed()
{
    local string sTemp;

    if ((bMapsOnly) && ((LastMapCount) < (MapsOnlyCount/2)))
        return;             // 2             // 1

    if (VoteButton.bDisabled)
        return;

    if (MapVoteStatusListItem(ListVoteStatus.SelectedItem) != None)
    {
        sTemp = MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName;
        DebugLog("VoteWindow - VoteButtonPressed - Status Map = "$sTemp);
    }

    if (sTemp ~= "Random Map")
    {
        ButRandMapPressed();
        return;
    }

    if (sTemp ~= "Random Game" || sTemp ~= "Remove Bots")
    {
        ButRandGamPressed();
        return;
    }

	if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
	{
		if ( getSelectedItem() != None )
		{
			if ( (Left(MapVoteUMenuList(getSelectedItem()).MapName,4) != "[XX]") || bAdmin)
			{
				sTemp = MapVoteUMenuList(getSelectedItem()).MapName;
				if (sTemp != "")
				{
				   if (CheckForGame(sTemp))
				   {
				      GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"GAME "$sTemp);
				   }
				   else
				   {
				      GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"MAP "$sTemp);
				   }
				}
				LastVoteTime = GetPlayerOwner().Level.TimeSeconds;
			}
		}
	}
}

function ButRandMapPressed()
{
    if ((bMapsOnly) || ((LastMapCount) < (MapsOnlyCount/2)))
        return;

    if (ButRandMap.bDisabled)
        return;

	if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
	{
       GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"MAP [RR]Random");
	   LastVoteTime = GetPlayerOwner().Level.TimeSeconds;
       ButRandMap.bDisabled = True;
    }
}

function ButRandGamPressed()
{
    if ((bMapsOnly) || ((LastMapCount) < (MapsOnlyCount/2)))
        return;

    if (ButRandGam.bDisabled)
        return;

	if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
	{
       if (bNoBots)
           GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"GAME [RG]Random");
       else
           GetPlayerOwner().ConsoleCommand("SAY !KillBots");
	   LastVoteTime = GetPlayerOwner().Level.TimeSeconds;
       ButRandGam.bDisabled = True;
    }
}

function int GetListNum (string ItemName)
{
	local int iNum;

    if ( ItemName == "")
        iNum = 0;
    else
	if ( MapListBox.isItemInList(ItemName) )
		iNum = 1;
	else
		iNum = 2;

	return iNum;
}

function FindGameMap(string sGame)
{
     local int i;

     GameMap = "";
     for (i=0; i<200; i++)
     {
         if (GameList[i] == sGame)
         {
             GameMap = GameMaps[i];
             break;
         }
     }
}

function bool CheckForGame(string sGame)
{
    local int i;

    for (i=0; i<200; i++)
    {
        if (GameList[i] == "" && i > 0)
            break;
        if (GameList[i] == sGame)
            return true;
    }
    return false;
}

function Tick (float DeltaTime)
{
	if ( (SelectionTime != 0) && (GetPlayerOwner().Level.TimeSeconds > SelectionTime + 1) )
	{
		if ( getSelectedItem() != None )
		{
		    if (bGameSelect)
		    {
		        if (GameMap == "")
		        {
		            Screenshot = NONE;
		            MapTitle = "";
		        }
		        else
		        {
		            SetMap(GameMap);
		        }
		    }
		    else
		    {
			   SetMap(MapVoteUMenuList(getSelectedItem()).MapName);
			}
			SelectionTime = 0.00;
		}
	}
	Super.Tick(DeltaTime);

	CheckForMapGame();

    if (!bGrayedOut && Left(sTitle, 8) != "MapVoteX")
    {
       VoteButton.bDisabled = True;
       bGrayedOut = True;
    }

    if ( MVGRI == none )
    {
       foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
       break;
    }
}

function CheckForMapGame()
{
    local string sTemp;
    local int i;

    if (EditMesg.GetValue() != TextEdit)
    {
        lblFind.SetText("");
        TextEdit = EditMesg.GetValue();
        i = InStr(Caps(TextEdit),"?");
        if (i >= 0)
        {
            sTemp = Mid(TextEdit, i+1);
            if (sTemp != "")
                bFindMap = MapListBox.Search(sTemp);
            return;
        }

        i = InStr(Caps(TextEdit),"/");
        if (i >= 0)
        {
            sTemp = Mid(TextEdit, i+1);
            if (sTemp != "")
                bFindGam = GameListBox.Search(sTemp);
        }
    }
}

function SetMap(string MapName)
{
	local int i;
	local LevelSummary L;
	local string RealMapName;

	bMapAlreadySet = True;

	i = InStr(Caps(MapName),".UNR");
	if ( i != -1 )
	{
		MapName=Left(MapName,i);
	}
	RealMapName = CheckMapname(MapName);
	Screenshot = Texture(DynamicLoadObject(RealMapName $ ".Screenshot",Class'Texture'));
	L = LevelSummary(DynamicLoadObject(RealMapName $ ".LevelSummary",Class'LevelSummary'));

	if ( Left(MapName,4) == "[XX]" )
	{
		MapTitle = "Voting not Permitted";
		IdealPlayerCount="";
	}
	else
	{
		if ( L != None )
		{
			MapTitle = L.Title;
			IdealPlayerCount = L.IdealPlayerCount;
		}
		else
		{
		    if (bGameSelect)
		        MapTitle = "";
		    else
			    MapTitle = "DownLoad Required";
			IdealPlayerCount = "";
		}
	}
}

function string CheckMapname (string sMap)
{
	if ( Left(sMap,4) ~= "[XX]" || Left(sMap,4) ~= "[GG]")
	{
		sMap = Mid(sMap,4);
	}
	return sMap;
}

function DrawGradient(Canvas C)
{
    if (class'MapVotePosition'.default.GradientStyle == 0)
        DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'Grad1');
    else
    if (class'MapVotePosition'.default.GradientStyle == 1)
        DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'Grad2');
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	Super.Paint(C,MouseX,MouseY);

    C.DrawColor = class'MapVotePosition'.default.BackGroundColor;
    DrawGradient(C);

	C.DrawColor.R=0;
	C.DrawColor.G=0;
	C.DrawColor.B=64;

    DrawStretchedTexture(C, 20 + MapListwidth, 155, MapListwidth+5, 110, Texture'UnrealShare.NewBlue');

	if ( !bMapAlreadySet && (LogoTexture != "") && (Screenshot == None) )
	{
		Screenshot=Texture(DynamicLoadObject(LogoTexture,Class'Texture'));
		bMapAlreadySet=True;
	}

	if ( Screenshot != None )
	{
		C.DrawColor = TextColor;
		DrawStretchedTexture(C, 20 + MapListwidth, 155.00, MapListwidth+5, 110.00, Screenshot);
	}

	if ( MapTitle != "" )
	{
		lblMaptxt.SetText(MapTitle);
	}
	else
	{
		lblMaptxt.SetText("");
	}

    if (bMapsOnly)
    {
        C.DrawColor = TextColor;
        DrawStretchedTexture(C, 20 + MapListwidth,  26, MapListwidth+5, 110, Texture'CopyR');
    }
    else
        GameListBox.ThisGame = ThisGame;
    CheckFavorites();
}

function CheckFavorites()
{
    if ( MVGRI == none )
    {
        foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
        break;
    }

    if (MVGRI.bDoFavor && MVGRI.bGameEnded && GetPlayerOwner() != None && GetPlayerOwner().GameReplicationInfo != None)
    {
        AddToFavorites(GetPlayerOwner());
    }
}

simulated function AddToFavorites(PlayerPawn PP)
{
    local string sIP, sPT, sTemp, sName;
	local int i, j, k;

    j = class'UBrowserFavoritesFact'.default.FavoriteCount;
    if (j < 99)
    {
  	    sTemp = GetPlayerOwner().Level.GetAddressURL();
  	    k = InStr(sTemp, ":");
  	    sIP = Left(sTemp, k);
  	    sPT = Mid(sTemp, k+1);
  	    k = int(sPT);
  	    sPT = string(k+1);
  	    sName = MVGRI.SvrName;

  	    for (i=0; i<j; i++) // check to see if already in favs
	    {
		    k = Instr(class'UBrowserFavoritesFact'.default.Favorites[i], "\\"$sIP$"\\"$sPT);
		    if (k >= 0)
		        return;
	    }

	    if (sName == "")
	        sName = "UnKnown";

	    sName = sName$"\\"$sIP$"\\"$sPT$"\\False";
	    class'UBrowserFavoritesFact'.default.Favorites[j] = sName;
	    class'UBrowserFavoritesFact'.default.FavoriteCount = j + 1;
	    class'UBrowserFavoritesFact'.SaveConfig();
	    class'UBrowserFavoritesFact'.static.StaticSaveConfig();
	}
}

function KeyDown (int Key, float X, float Y)  // 33=pgup 34=pgdn
{
    ParentWindow.KeyDown(Key,X,Y);
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}

function DebugLog(string Msg)
{
	if (bDebugMode)
	    Log("**** " $ Msg);
}

defaultproperties
{
    SilvColor=(R=160,G=160,B=160)
    GrayColor=(R=32,G=32,B=32)
   	TextColor=(R=255,G=255,B=255)
	YellColor=(R=255,G=255,B=10)
}
