//================================================================================
// MapVoteWindowWelcome.
//================================================================================

class MapVoteWindowWelcome extends UWindowPageWindow;

var MapVoteGRI MVGRI;

var color WhiteColor, GrayColor;

var UWindowComboControl WelCombo;
var MapVoteSmallButton  SubmitButton;
var UWindowSmallButton  CloseButton;

var string LeftBtnUrl;
var string MidBtnUrl;
var string RightBtnUrl;

var string MenuLogoName;
var string MenuSoundName;
var bool   bStretch;

var Texture WelcomeLogo;
var Sound   WelcomeSound;

var bool bSoundDone;

var string Servername;
var string ServerPort;
var string ServerIP;

var WindowConsole WC;
var float Guix;
var int EngVer;

function Created ()
{
    local string sTemp;

	Super.Created();

    CheckGRI();

    EngVer = int(GetPlayerOwner().Level.EngineVersion);
    Guix = 1.000000;

    if (EngVer > 468)
    {
        WC = WindowConsole(GetPlayerOwner().Player.Console);
        if (!WC.bCreatedRoot || WC.Root == none)
            WC.CreateRootWindow(None);

        if (WC.Root != none)
        {
            sTemp = WC.Root.GetPropertyText("AutoGUIScale");
            if (sTemp ~= "False")
            {
                sTemp = WC.Root.GetPropertyText("ConfiguredGUIScale");
                Guix = float(sTemp);
            }
        }
    }

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 315, 295, 70, 20));
	CloseButton.DownSound=Sound'GlassTink1';
	CloseButton.Text="Close";

    SetAcceptsFocus();
}

function SetupLinks()
{
    CheckGRI();

    if (MVGRI.GetDropLink(0, 0) != "")
    {
	    WelCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 84, 294, 227, 20));
	    WelCombo.SetFont(F_Normal);
	    WelCombo.EditBoxWidth = 227;
	    WelCombo.SetEditable(False);
	    WelCombo.EditBox.Value = "           ------ Select a Server Link ------";

        SubmitButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton',10, 295, 70, 20));
        SubmitButton.DownSound=Sound'GlassTink1';
	    SubmitButton.Text="Submit";
    }

}

function CheckGRI()
{
    if ( MVGRI == none )
    {
        foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
        break;
    }
}

function Notify (UWindowDialogControl C, byte E)
{
    Super.Notify(C,E);

    Switch(E)
    {
	  case DE_Click:
	  switch(C)
      {
      case SubmitButton:
           if (SubmitButton.bDisabled == false)
           {
              SubmitSelection();
              ParentWindow.ParentWindow.Close();
           }
           break;
	  case CloseButton:
	       ParentWindow.ParentWindow.Close();
		   break;
      }
      break;
    }
}

function SubmitSelection()
{
	local string sLink;
	local int iSelect;

    CheckGRI();

	iSelect = WelCombo.GetSelectedIndex();            // title num
	sLink = MVGRI.GetDropLink(iSelect, 1);            // url
	Log("MapVoteX: PlayerTravel - Title = "$MVGRI.GetDropLink(iSelect, 0)$" | Link = "$sLink);
	OpenURL(sLink);
}

function SetupCombo()
{
    local string sTemp;
    local int i;

    CheckGRI();

    for (i=0; i<25; i++)
    {
        sTemp = MVGRI.GetDropLink(i, 0);
        if (sTemp == "")
            break;
        WelCombo.AddItem(sTemp);
    }
}

function OpenURL(string URL)
{
	local string sName;

	sName = "?Name="$GetPlayerOwner().PlayerReplicationInfo.PlayerName;

	if (Left(URL, 3) ~= "www")
		GetPlayerOwner().ConsoleCommand("start https://"$URL);
	else
	if (Left(URL, 7) ~= "http://" || Left(URL, 8) ~= "https://")
		GetPlayerOwner().ConsoleCommand("start "$URL);
	else
	if (Left(URL, 9) ~= "unreal://" )
		GetPlayerOwner().ClientTravel(URL$sName, TRAVEL_Absolute, false);
	else
		GetPlayerOwner().ClientTravel("unreal://"$URL$sName, TRAVEL_Absolute, false);

	Close();
	Root.Console.CloseUWindow();
}

function Paint (Canvas C, float MouseX, float MouseY)
{

	Super.Paint(C,MouseX,MouseY);

    C.DrawColor  = WhiteColor;

    DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'BlackTexture');

    if (WelcomeLogo == None && InStr(MenuLogoName, ".") > 0)
        WelcomeLogo = Texture(DynamicLoadObject(MenuLogoName, class'Texture'));

    if (WelcomeLogo != None)
    {
        if (bStretch)
           DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,WelcomeLogo);
        else
        {
           C.SetPos(WinWidth * Guix * 0.144, 10);
           if (WelcomeLogo.USize <= 256)
               C.DrawIcon( WelcomeLogo,  1.1 * Guix);
           else
           if (WelcomeLogo.USize <= 512)
               C.DrawIcon( WelcomeLogo,  0.55 * Guix );
           else
           if (WelcomeLogo.USize <= 1024)
               C.DrawIcon( WelcomeLogo,  0.275 * Guix );
           else
               DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'mvxw');
        }
    }
    else
    {
        C.SetPos(70, 25);
        DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'mvxw');
    }

    if (WelcomeSound == None && InStr(MenuSoundName, ".") > 0)
        WelcomeSound = Sound(DynamicLoadObject(MenuSoundName, class'Sound'));

    if (WelcomeSound != None && !bSoundDone)
    {
        bSoundDone = true;
        GetPlayerOwner().PlaySound(WelcomeSound);
    }
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}

defaultproperties
{
    WhiteColor=(R=255,G=255,B=255)
}
